<?php

/**
 ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 :: Arki-DB                                                              ::
 :: (c) 2002 The Arki-DB Development Team                                ::
 ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 :: This program is free software; you can redistribute it and/or modify ::
 :: it under the terms of the GNU General Public License as published by ::
 :: the Free Software Foundation; either version 2 of the License, or    ::
 :: (at your option) any later version.                                  ::
 ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 
**/

/** --------------------------------------------
 * Arki-DB Core
 *
 * @author Ali Islami ( master@arkitus.com ) 
 *  -Modified Erik Karulf ( scriptmaster@alphamonkey.net )
 **/
 
class ArkiDB 
{
	//Foreword : Im editing this and for some reason, looking back on it, I was very disgruntled...
	//
	//
	//Ok. This will get redone. We have SO many variables that could be condensed into either an array
	//or a class or just simply erased all together. We need to implement a session table in mySQL
	//DB and some others need to be made into a class. ArkiDB 2 will break away from this class only 
	//setup, and will provide more of a combination system, much like phpBB or XOOPS
	//
	//The new setup will be a serialized ACL table put into the session. The session table in mySQL will
	//contain a few colums, but with little actual data. sid, uid, hash, status, mlevel, creation, release
	//-alpha
	//
 	var $version		= 'v1.0';	// Arki-DB's current version
 	var $session		= array();		// Holds the session info ( accesable as an array );
 	var $session2		= array();		// Core info, not accesable
 	var $config		= array();		// Holds the data(array) retrieved from the tables
 	var $get		= array();		// The Query String that gets recieved from the URL
 	var $self		= array();		// This->self!!
 	var $encoding		= array();		// The array that holds the coding methods supported by the browser
 	var $post		= array();		// The array that holds the data sent from a form
 	var $upload		= array();		// The array that holds the uploaded files
 	var $language		= array();		// Holds ArkiDB's language strings
 	var $method;					// Get\POST?
 	var $lang;					// Arki-DB's language name
 	var $date;					// The date!
 	var $title;					// The title of all the pages
 	var $skinid;					// The skin id ( used for including the files :: $skin = './templates/' . $skinid . '/' . $skin; )
 	var $entries;					// Name of the entry in plural form. eg. Files, Pictures, Links.
	var $entry;					// Name of the entry in sungular form. eg. File, Picture, Link.
	var $views;					// Plural form of the verb that can be acted on the entry. eg. Downloads, Views, Visits.
	var $showstats;					// Show the stats at the bottom?
	var $viewentry;					// Allow guests to view entries?
	var $emoticons;					// Show emoticons?
	var $usersubmit;				// Can the users submit entries themself?
	var $view;					// Singular form of the verb that can be acted on the entry. eg. Download, View, Visit.
 	var $template;					// Reference for parsed class
	var $globals;					// Reference for parsed class
 	var $header;					// Reference for parsed class
 	var $footer;					// Reference for parsed class
 	var $var;					// General variable
 	var $optionid;					// The id of the option set. Used for the entry page
 	var $div;					// Do extra fields have seperate scrollbars?
 	var $height;					// Scrollable area
 	var $url_start;					// The URL used for the sort by links
 	var $url_sort;					// The URL used for the starting page links
 	var $sort;					// Sort by...?
 	var $limit;					// The number of entries should be shown in a category
 	var $start;					// The number of entries we skip
 	var $maxfilesize;				// The maximum file size allowed for uploads
 	var $root;					// The root URL of the database	
 	var $submitter;					// Display the name of the submitter or not?
 	
 	
 	
 	/** --------------------------------------------
 	 * (class 'ArkiDB') constructor
 	 *
	 * @author Ali Islami ( master@arkitus.com )
	 **/
	 
	 function ArkiDB()
	 {
		global $_GET, $HTTP_POST_FILES, $HTTP_SESSION_VARS ;
		
	 	$this->get		= $_GET;							// Set $this->get
	 	$this->post		= $_POST;							// Set $this->post
		$this->method		= $_SERVER["REQUEST_METHOD"]; 					// GET\POST?
	 	$this->upload		= $HTTP_POST_FILES;						// Set $this->upload
	 	$this->encoding		= $_SERVER['HTTP_ACCEPT_ENCODING'];				// Set $this->encoding
	 	$this->url_start	= $_SERVER['PHP_SELF'];
	 	$this->url_sort		= $_SERVER['PHP_SELF'];
	 	$this->session2		= $HTTP_SESSION_VARS;							// Set $this->session
	 	$this->db($db, $query, '3'); 								// Connect to the mySQL database
	 	
	 	if ( $this->get('entryid') == '' AND $this->get('catid') != '')
	 	{
	 		$config = $this->getConfig($this->get('catid'));		// Get configuration details for table	
	 	}
	 	elseif ( $this->get('entryid') != '' AND $this->get('catid') == '')
	 	{
	 		$entryid = $this->get('entryid');
	 		$entry = $this->db($db, "SELECT entrycatid FROM arkidb_entries WHERE id = '$entryid'", '1:2');
	 		$config = $this->getConfig($entry['entrycatid']);		// Get configuration details for table	
	 	}
	 	else
	 	{
	 		$config = $this->getConfig($catid);				// Get configuration details for table	
	 	}
	 	
	 	$this->date_l		= date( 'D M d, Y' );				// Set date
	 	$this->date_s		= date( 'd/m/y' );				// Set date
	 	$this->lang		= $config['language'];				// Sets the config var
	 	$this->title		= $config['title'];				// Sets the config var
	 	$this->skinid		= $config['skinid'];				// Sets the config var
	 	$this->entries		= $config['entries'];				// Sets the config var
	 	$this->entry		= $config['entry'];				// Sets the config var
	 	$this->views		= $config['views'];				// Sets the config var
	 	$this->view		= $config['view'];				// Sets the config var
	 	$this->showstats	= $config['showstats'];				// Sets the config var
	 	$this->emoticons	= $config['emoticons'];				// Sets the config var
	 	$this->usersubmit	= $config['usersubmit'];			// Sets the config var
	 	$this->div		= $config['div'];				// Sets the config var
	 	$this->height		= $config['height'];				// Sets the config var
	 	$this->maxfilesize	= $config['maxfilesize'];			// Sets the config var
	 	$this->root		= $config['root'];				// Sets the config var
	 	$this->limit		= $config['limit'];				// Sets the config var
	 	$this->viewentry	= $config['viewentry'];				// Sets the config var
	 	$this->submitter	= $config['submitter'];				// Sets the config var
	 	$this->sort		= $this->get('sort');				// Sets the sort var
	 	$this->start		= $this->get('start');				// Sets the start var
		$this->getLanguage($config['language']);				// Sets the language
		$this->session 		= $this->decodeSession($this->session2['session']); 	// Decodes the session information
	
	 }
	 
	 /** --------------------------------------------
 	 * mySQL database connector and query caller
 	 *
	 * param string $db database name
	 * param string $query mySQL query
	 * param int $type type of action to perform
	 * @author Ali Islami ( master@arkitus.com )
	 **/
	
         function db($db,$query,$type) 
         {
         	global $db, $result;
		
                switch ($type)
                {
                	//--------------------------------------------
                	// Simply query!
                	//--------------------------------------------
                	
                	case '0':
                		$result = mysql_query($query);
                		return $result;
                		break;
                	
                	//--------------------------------------------	
                	// I have already queried, just fetch the array               		
                	//--------------------------------------------
                	
                	case '1':
                        	$array = mysql_fetch_array($result);
				return $array;
				break;
			
			//--------------------------------------------
                	// I have not queried, so query and fetch the array
                	//--------------------------------------------
                	
                	case '1:2':
                		$result = mysql_query($query);
                        	$array = mysql_fetch_array($result);
				return $array;
				break;
				
			//--------------------------------------------
                	// I have already queried, just fetch the number of rows
                	//--------------------------------------------
                	
			case '2':
				$array = mysql_num_rows($result);
				return $array;
				break;
				
			//--------------------------------------------
                	// I have not queried, so query and fetch the number of rows
                	//--------------------------------------------
                	
			case '2:2':
			        $result = mysql_query($query);
				$array = mysql_num_rows($result);
				return $array;
				break;
				
			//--------------------------------------------
                	// Connect to database
                	//--------------------------------------------
                	
			case '3':
				$this->dbc = mysql_pconnect($db['host'],$db['user'],$db['pass'])	// Starting in BETA-4 This was changed to pconnect for speed reasons -Erik
					or die ("SQL Connection Error");
                		mysql_select_db($db['name'],$this->dbc)
					or die ("Database Not Found\Denied Access");

		}
                @mysql_free_result($result);     
         }
         
         /** --------------------------------------------
 	 * A script that merges two different arrays into one array. It isn't currently 
 	 * used in the script, but i really enjoyed coding it! haha!
 	 *
	 * param string $queryone either an array( key ) or a mySQL query string
	 * param string $querytwo either an array( value ) or a mySQL query string
	 * @author Ali Islami ( master@arkitus.com )
	 **/
	 
         function returnKeyVal ( $queryone, $querytwo )
         {
         	if (gettype($queryone) == 'string' AND gettype($querytwo) == 'string')
         	{
         		$keyreturn = $this->db($db, $queryone, '1');
         		$valreturn = $this->db($db, $querytwo, '1');

         	}
         	
         	$keynum = $this->db($db, $queryone, '2');
         	$valnum = $this->db($db, $querytwo, '2');
         	
         	if ( $keynum != $valnum )
         	{
         		die ('Wrong arrays passed into function returnKeyVal in global.php');
         	}
         	else
         	{
  			if (is_array($keyreturn) == FALSE || is_array($valreturn) == FALSE)
   			{
        			die ('Wrong arguments passed into function returnKeyVal in global.php');
   			}
  			foreach ($keyreturn as $x => $y)
  			{
      				 $new[$y] = $values[$x];
  			}
  			print_r($new);
			return $new;
		}
	 }
	  /** -------------------------------------------- 
 	  * Template Engine which transforms HTML pages into PHP functions.
 	  *
 	  * @param string $skin the name of the skin to be loaded
	  * @author Ali Islami ( master@arkitus.com )
	  **/
	  
	  function renewTemplate($skin)
	  {
	  	
	  	//--------------------------------------------
	  	// Where is the template?
	  	//--------------------------------------------
	  	
			$skinroot = './templates/' . $this->skinid . '/' . $skin . '.tpl';
			$configroot = './templates/' . $this->skinid . '/config/' . $skin . '.php';		
				
		//--------------------------------------------
		// Open it and make it ready for editting
		//--------------------------------------------
		
			$skinopen = fopen ( $skinroot, 'r' );
			$skinsize = filesize ( $skinroot );
			$skin = fread ( $skinopen, $skinsize );
			fclose($skinopen);
		
		//--------------------------------------------
		// Now comes the tricky part: We should transform the templates
		// into some format the php understands. We will make a class
		// for each template, and some functions. Note that the order 
		// should NOT be changed, as it wont work anymore :D
		//--------------------------------------------
		
		// Replace brackets so that they become variables
			
			$skin = str_replace ("{", "\$tpl[", $skin);
			$skin = str_replace ("}", "]", $skin);
		
		// Messy escape, for javascript
		
			$skin = str_replace ("<%", "{", $skin);
			$skin = str_replace ("%>", "}", $skin);
		
		// Create the class and close it
		
			$skin = str_replace ("<!-- START TEMPLATE -->", "<?php\n\nclass template extends ArkiDB\n{", $skin);
			$skin = str_replace ("<!-- END TEMPLATE -->", "}\n\n?>", $skin);
		
		// Create each function and close it
		
			$skin = str_replace ("<!-- START", "function", $skin);
			$skin = str_replace (" START -->", "(\$tpl)\n{\necho <<<EOF", $skin);
			$skin = str_replace ("<!-- END -->", "EOF;\n}", $skin);
		
		// Now write the result into a php file in the config root
		
			$skinopen = fopen ( $configroot, 'w+' );
			fwrite ( $skinopen, $skin, strlen($skin));
			fclose($skinopen);
		
		return true; 
	  }
	  
	  function renewGlobals()
	  {
	  	//--------------------------------------------
	  	// Where is the template?
	  	//--------------------------------------------
	  	
			$skinroot = './templates/' . $this->skinid . '/global.tpl';
			$configroot = './templates/' . $this->skinid . '/config/global.php';		
		
		//--------------------------------------------
		// Open it and make it ready for editting
		//--------------------------------------------	
			
			$skinopen = fopen ( $skinroot, 'r' );
			$skinsize = filesize ( $skinroot );
			$skin = fread ( $skinopen, $skinsize );
			fclose($skinopen);
		
		//--------------------------------------------
		// Create the credits at the bottom. This should NOT be changed 
		// at all, not even one word. Its has been ripped from the templates
		// so that no-one finds any excuses!
		//--------------------------------------------
		
			$credit = "function credits(\$tpl)\n{\necho <<<EOF\n<table width='90%' align='center'><tr><td align='center' id='credit'>\$tpl[CREDIT]</td></tr></table><br>\nEOF;\n}\n}\n\n?>";
  
		//--------------------------------------------
		// Now comes the tricky part: We should transform the templates
		// into some format the php understands. We will make a class
		// for each template, and some functions. Note that the order 
		// should NOT be changed, as it wont work anymore :D
		//--------------------------------------------
		
		// Replace brackets so that they become variables
		
			$skin = str_replace ("{", "\$tpl[", $skin);
			$skin = str_replace ("}", "]", $skin);
		
		// Messy escape, for javascript
		
			$skin = str_replace ("<%", "{", $skin);
			$skin = str_replace ("%>", "}", $skin);
		
		// Create the class and close it
		
			$skin = str_replace ("<!-- START TEMPLATE -->", "<?php\n\nclass globals extends ArkiDB\n{", $skin);
			$skin = str_replace ("<!-- END TEMPLATE -->", $credit, $skin);
		
		// Create each function and close it
		
			$skin = str_replace ("<!-- START", "function", $skin);
			$skin = str_replace (" START -->", "(\$tpl)\n{\necho <<<EOF", $skin);
			$skin = str_replace ("<!-- END -->", "EOF;\n}", $skin);
		
		// Now write the result into a php file in the config root
		
			$skinopen = fopen ( $configroot, 'w+' );
			fwrite ( $skinopen, $skin, strlen($skin));
			fclose($skinopen);
		
		return true; 
	  }
	  
	  /** --------------------------------------------
	  * Gets the templates, and makes it ready for use!
	  *
	  * param string $skin name of the skin 
	  * @author Ali Islami ( master@arkitus.com )
	  **/
	  
	  function getTemplate($skin)
	  {
		$skinroot = './templates/' . $this->skinid . '/config/' . $skin . '.php';
	  	require_once $skinroot;
	  	$this->template =& new template;
	  }

	  /** --------------------------------------------
 	  * Print the selected function in the template ( dynamic block )
 	  *
	  * param string $fname function(dynamic block) name  
	  * param array $farg array of replacements
	  * @author Ali Islami ( master@arkitus.com )
	  **/
	  
	  function tprint($fname, $farg)
	  {
	  	// WTF? Why is this here? -alpha
		//$this->db($db, "UPDATE `arkidb_entries` SET `entryrating` = '$rating' WHERE `id` = '$entryid'", '0');
		// This is disabled until someone tells my why this is here...
	  	if ( is_array($farg))
	  	{
			$this->template->$fname($farg);
		}
	  }
	  
	  /** --------------------------------------------
	  * param string $language name of the language 
	  * @author Ali Islami ( master@arkitus.com )
	  **/
	  
	  function getLanguage($language)
	  {
		if ($language == NULL)
		{
			$language = 'Polish';
		}
		require_once './language/' . $language . '.php';
		$this->language = $lng;
	  }
	  
	  
	  /** --------------------------------------------
 	  * retrieves the info from the mySQL database into the config array
 	  *
	  * param string $fname function(dynamic block) name  
	  * param array $farg array of replacements
	  * @author Ali Islami ( master@arkitus.com )
	  * @started 2002/7/19
	  **/
	  
	  function getConfig($catid)
	  {

		$cat = $this->db($db, "SELECT * FROM arkidb_cats WHERE id = '$catid'", '1:2');
		$optionid = $cat['categoryoptionid'];
		$this->optionid = $optionid;	
		
		//--------------------------------------------
		// Collect the global options
		//--------------------------------------------
		
		//Ugh. This just needs to be re-done. Using the array functions in php this could be simplified into one big call
		//The call would be a 1:2 - and it would be a straight copy construct
	  	$result = $this->db($db, "SELECT optionname, optionvalue FROM arkidb_options  WHERE optionid = '0'", '0');
	  	while ($configuration = mysql_fetch_object($result))
	 	{
	 		$config["$configuration->optionname"] = $configuration->optionvalue;
	 	}
	 	
	 	//--------------------------------------------
		// Collect the local options
		//--------------------------------------------
	 	
	 	$result = $this->db($db, "SELECT optionname, optionvalue FROM arkidb_options  WHERE optionid = '$optionid'", '0');
	  	while ($configuration = mysql_fetch_object($result))
	 	{
	 		$config["$configuration->optionname"] = $configuration->optionvalue;
	 	}
	 	
	 	return $config;
	  }
	  
	  /** --------------------------------------------
 	  * Prints the header and footer.
 	  *
	  * @author Ali Islami ( master@arkitus.com )
	  * @started 2002/7/19
	  **/
	  
	  function getGlobals($type)
	  {
	  	//--------------------------------------------
		// Set the variables
		//--------------------------------------------
	  	$catid = $this->get('catid');
	  	$entryid = $this->get('entryid');
	  	$action = $this->get('action');
		
		//--------------------------------------------
		// Get the template file
		//--------------------------------------------
		$skinroot = './templates/' . $this->skinid . '/config/global.php';
	  	
	  	if ( $action != 'printentry' ) // Override header and footer if it's the Print Entry page
	  	{
	  		
	  		//--------------------------------------------
			// What type is it?
			//--------------------------------------------
	  		
			if ( $type == 'header' )
			{
				require_once $skinroot;
				$this->globals =& new globals;
				$this->startTimer();
				$locbar = $this->locBarIdentify();
				
				//--------------------------------------------
				// What's the title? This can be removed :(
				//--------------------------------------------
				
				$title = $this->title . ' ' . '( ' . $this->language['powered'] . ' Arki-DB )';
			
				//--------------------------------------------
				// Is the user logged in? If not, print the login and register info
				//--------------------------------------------
				
				if ( $this->session['logged'] != 'loggedin' )
				{
					$nav2 = "[ <a href='index.php?action=users&useraction=loginform'> " . $this->language['login'] . "</a> ] [ <a href='index.php?action=register'>" . $this->language['register'] . "</a> ] " ;
				}
				elseif ( $this->session['logged'] == 'loggedin')
				{
					//--------------------------------------------
					// Is the user an admin? If so, print the CP link
					//--------------------------------------------
					if ( $this->session['level'] == 'admin' )
					{
						$nav2 .= "[ <a href='index.php?action=users&useraction=loginform&redirect=true' target='_blank'>" . $this->language['admincp'] . '</a> ] ' ;
						
						//--------------------------------------------
						// Is the admin viewing a category? If so, print the submit link
						//--------------------------------------------
						
						if (isset($catid))
						{
							$nav .= "[ <a href='index.php?action=addentry&catid=" . $catid . "'  target='_blank'>" . $this->language['addentry'] . '</a> ] :: ' ;
						}
						
						//--------------------------------------------
						// Is the admin viewing an entry? If so, print the edit and delete links
						//--------------------------------------------
						
						if (isset($entryid))
						{
							$nav .= "[ <a href='index.php?action=admin&admin=editentry&entryid=" . $entryid . "'  target='_blank'>" . $this->language['editentry'] . '</a> ] ';
							$nav .= "[ <a href='index.php?action=admin&admin=deleteentry&entryid=" . $entryid . "'  target='_blank'>" . $this->language['deleteentry'] . '</a> ] :: ' ;
						}
					}
					else
					{
						//--------------------------------------------
						// Can users submit entries in this category?
						//--------------------------------------------
						
						if ( $this->usersubmit == '1' )
						{
						
							//--------------------------------------------
							// Make sure that we are in a category
							//--------------------------------------------
								
							if (isset($catid))
							{
								$nav .= "[ <a href='index.php?action=addentry&catid=$catid'>" . $this->language['addentry'] . '</a> ] ' ;
							}
						}
					}
					
					// Logoff
					
					$nav2 .= "[ <a href='index.php?action=users&useraction=logoff'>" . $this->language['logoff'] . '</a> ] ' ;
				}
			
				$nav .= "[ <a href='index.php?action=search'> " . $this->language['search'] . '</a> ]' ;
				$info = array ( 'TITLE'		=> $title,
						'NAV'		=> $nav,
						'NAV2'		=> $nav2,
				    		'SKINID'	=> $this->skinid,
				    		'LOCBAR'	=> $locbar,
				    		'DATE'		=> $this->date_l );
				$this->globals->head($info);
			}
			elseif ( $type == 'footer' )
			{
				$session = array();			
				$exec_time = $this->endTimer();
				
				//--------------------------------------------
				// Should we show the statistics?
				//--------------------------------------------
				
				if ( $this->showstats == 1 )
				{
					$mysql_queries = $this->db($db, $query, '3');
					if ( $this->session['name'] != "" )
					{
						$stat = '[ ' . $this->language['loggedinas'] . ' ' . $this->session['name'] . ' ] ';
					}
					$stat .= '[ ' . $this->language['exectime'] . ' ' . $exec_time . ' ]';
				}
				
				//--------------------------------------------
				// Show the jump menu
				//--------------------------------------------
				// This. This could be condensed into a while loop and a few ifs. We dont need two calls, using the order by correctly (twice) this wont be a problem. -alpha
				$jump = "<form name='form'><select name='catid' onChange=\"MM_jumpMenu('parent',this,0)\"><option selected>" . $this->language['jump'] . "<option value='index.php'>----------------------";
				$result_super = $this->db($db, "SELECT * FROM arkidb_cats WHERE categorylevel=0 ORDER BY categoryflag", 0);
				while ( $category_super = mysql_fetch_object( $result_super ))
				{
					$name = $category_super->categoryname;
					$level = $category_super->categorylevel + 1;
					$jump .= "<option value='index.php?action=view&view=category&catid=$category_super->id&catflag=$category_super->categoryflag&catlevel=$level'>$name";
					
					$result = $this->db($db, "SELECT * FROM arkidb_cats WHERE categoryparent = $category_super->id ORDER BY categorylevel", 0);
					while ( $category = mysql_fetch_object( $result ))
					{
						$dash = '';			
						for ( $i=1; $i <= $category->categorylevel; $i++ )
						{
							$dash .= '- ';
						}
						$level = $category->categorylevel + 1;
						$name = $this->couple($dash, $category->categoryname);
						$jump .= "<option value='index.php?action=view&view=category&catid=$category->id&catflag=$category->categoryflag&catlevel=$level'>$name";
					}
						
				}
				$jump .= "</select></form>";

				//--------------------------------------------
				// This is the link to arkitus.com. You cannot 
				// change this in ANY means. If you want to change
				// the colours, use the CSS files
				//
				// Think of the many hours spent on the script, 
				// and it could have not been free...
				//--------------------------------------------
				
				$credit = $this->language['powered'] . ': ' . "<a href='http://www.arkitus.com' target='_blank'>Arki-DB</a> " . $this->version . " &copy 2004"; 
				$this->globals->foot(array( 'STAT'		=> $stat,
							    'JUMP'		=> $jump));
				$this->globals->credits(array( 'CREDIT'		=> $credit));
			}
		}
	  }
	  
	  /** --------------------------------------------
 	  * Makes a string with two words
 	  *
	  * param string $one string/var number one
	  * param string $two string/var number two
	  * @author Ali Islami ( master@arkitus.com )
	  * @started 2002/7/19
	  **/
	  
	  function couple($one, $two)
	  {
	  	$array = array ( $one, $two );
	  	$three = implode( " ", $array);
	  	return $three;
	  }
	  
	  /** --------------------------------------------
 	  * Generates the location bar
 	  *
	  * param string $id id number of the category/entry
	  * param array $type category/entry
	  * @author Ali Islami ( master@arkitus.com )
	  * @started 2002/7/19
	  **/
	  
	  function locationBar($id, $type)
	  {
		switch ($type)
		{
			//--------------------------------------------
			// Are we in a category?
			//--------------------------------------------
				
			case 'category':
				if ( isset ($id))
				{	//FIXME! FIXME! FIXME! FIXME! FIXME! FIXME! FIXME! FIXME! FIXME! FIXME! FIXME! FIXME! FIXME! FIXME!
					//This is where the shizat hits the fan. Ugh, two calls PER iteration in the loop.
					//AND two calls before the for loop even begins...
					//This would probably be easiest to just erase and re-code the SQL parts.
					//-alpha
					
					$info = $this->db($db, "SELECT * FROM arkidb_cats WHERE id = $id", '1:2');
					$number = $this->db($db, "SELECT categorylevel FROM arkidb_cats WHERE categoryflag = $info[categoryflag] ORDER BY categorylevel DESC LIMIT 0,1", '0');
	  				for ($i = 0; $i <= $number; $i++)
	  				{
						if ( $i == 0)
						{
							$cat = $this->db($db, "SELECT * FROM arkidb_cats WHERE id = $id", '1:2');
							$this->var = $cat['categoryparent'];
							$sublevel = $cat['categorylevel'] + 1;
							$url = "<a href ='index.php?action=view&view=category&catid=$cat[id]&catflag=$cat[categoryflag]&sublevel=$sublevel'>$cat[categoryname]</a>";
							$name = $this->couple($url,' | ');						
						}
						$cat = $this->db($db, "SELECT * FROM arkidb_cats WHERE id = '$this->var'", '1:2');
						$this->var = $cat['categoryparent'];
						if ( isset ($cat['categoryname']))
						{

							$sublevel = $cat['categorylevel'] + 1;
							$url = "<a href ='index.php?action=view&view=category&catid=$cat[id]&catflag=$cat[categoryflag]&sublevel=$sublevel'>$cat[categoryname]</a>";
							$name .= $this->couple($url,' | ');	
						}
						
					}
					$url = "<a href ='index.php'>" . $this->language['home'] . '</a>';
					$name .= $this->couple($url,'');
					
					$this->var = explode(" | ", $name);
					$array = array_reverse ($this->var);
					$this->var = implode(" -> ", $array);

	  			}
	  			else
	  			{
					$url = "<a href ='index.php'>" . $this->language['home'] . '</a>';
					$this->var = $this->couple($url,'');
				}
				break;
	
			//--------------------------------------------
			// Are we viewing an entry?
			//--------------------------------------------
	  		
	  		case 'entry':
	  			$entry = $this->db($db, "SELECT * FROM arkidb_entries WHERE id = $id", '1:2');
	  			$this->var = $this->locationBar($entry['entrycatid'], 'category');
	  			$url = "<a href ='index.php?action=view&view=entry&entryid=$entry[id]'>" . $entry['Name'] . '</a>';
				$this->var .= $this->couple(' -> ',$url);
	  			break;
	  		
	  		//--------------------------------------------
			// Are we viewing the stats?
			//--------------------------------------------
	  		
	  		case 'stats':
				$this->var = "<a href ='index.php'>" . $this->language['home'] . '</a> -> ' . "<a href ='index.php?action=stats'>" . $this->language['statistics'] . '</a>';
	  			break;
	  		
	  		//--------------------------------------------
			// Are we searching?
			//--------------------------------------------
			
			case 'search':
				$this->var = "<a href ='index.php'>" . $this->language['home'] . '</a> -> ' . "<a href ='index.php?action=search'>" . $this->language['search'] . '</a>';
	  			break;
	  		
	  		//--------------------------------------------
			// Are we commenting on an entry?
			//--------------------------------------------
				
			case 'comment':
				$this->var = $this->locationBar($id, 'entry');
				$this->var .= ' -> ' . "<a href ='index.php?action=comment&entryid=$id'>" . $this->language['comment'] . '</a>';
	  			break;
	  		
	  		//--------------------------------------------
			// Are we getting registered?
			//--------------------------------------------
					  			
	  		case 'register':
				$this->var = "<a href ='index.php'>" . $this->language['home'] . '</a> -> ' . "<a href ='index.php?action=register'>" . $this->language['register'] . '</a>';
	  			break;

	  		//--------------------------------------------
			// Are we login' in?
			//--------------------------------------------
				
	  		case 'login':
				$this->var = "<a href ='index.php'>" . $this->language['home'] . '</a> -> ' . "<a href ='index.php?action=users&useraction=loginform'>" . $this->language['login'] . '</a>';
	  			break;

			//--------------------------------------------
			// Are we in the admin CP?
			//--------------------------------------------
	  		
	  		case 'admin':
				$this->var = "<a href ='index.php'>" . $this->language['home'] . '</a> -> ' . "<a href ='index.php?action=admin'>" . $this->language['admincp'] . '</a> -> ' . "<a href ='index.php?action=admin&admin=$id'>" . $this->language[$id] . '</a>';
	  			break;
	  		
	  		//--------------------------------------------
			// Are we submitting an entry?
			//--------------------------------------------
			 			
	  		case 'addentry':
				$this->var = $this->locationBar($id, 'category');
				$this->var .= '-> ' . "<a href ='index.php?action=addentry&catid=$id'>" . $this->language['addentry'] . '</a>';
	  			break;
	  	}
	  	return $this->var;
	  }
	  
	  /** --------------------------------------------
 	  * Starts the timer ( used for the execution time stat )
 	  *
	  * param string $id id number of the category/entry
	  * param array $type category/entry
	  * @author Ali Islami ( master@arkitus.com )
	  * @started 2002/7/19
	  **/
	  
    	  function startTimer() 
    	  {
        	global $starttime;
        	$time = microtime ();
        	$time = explode (' ', $time);
        	$time = $time[1] + $time[0];
        	$starttime = $time;
    	  }
    	  
	  /** --------------------------------------------
 	  * Ends the timer ( used for the execution time stat )
 	  *
	  * param string $id id number of the category/entry
	  * param array $type category/entry
	  * @author Ali Islami ( master@arkitus.com )
	  * @started 2002/7/19
	  **/
	  
    	  function endTimer() 
    	  {
        	global $starttime;
        	$time = microtime ();
        	$time = explode (' ', $time);
        	$time = $time[1] + $time[0];
        	$endtime = $time;
        	$totaltime = round (($endtime - $starttime), 5);
        	return $totaltime;
    	  }
    	  
    	  /** --------------------------------------------
 	  * Retrieves the average rating the entry has
 	  *
	  * param string $id id number of the category/entry
	  * param array $type category/entry
	  * @author Ali Islami ( master@arkitus.com )
	  * @started 2002/7/19
	  **/
    	  
    	  function getRating($entryid) 
    	  {
		//Yea, so this can be done with two fast SQL calls and a division symbol
		//with rounding... If mysql_rows == 0 then return '$LANG['NOT_RATED']'
    	  	$result = $this->db($db, "SELECT * FROM arkidb_comments WHERE entryid = $entryid", 0);
	 	$this->var = 0;
	 	$average = array();
	 	while ( $rating = mysql_fetch_object($result))
	 	{
	 		if ($rating->rating != 0)
	 		{
	 			$this->var++;
	 			$total = $total + $rating->rating;
	 		}
	 	}
	 	if ( $this->var != 0)
	 	{
	 		$average['average'] = $total/$this->var;
	 		$average['average'] = round($average['average'], 2);
	 		$average['number'] = $this->var;
	 	}
	 	else
	 	{
	 		$average = '0';
	 	}
	 	return $average;
	  }
		
	  /** --------------------------------------------
 	  * Converts symbols to images
 	  *
	  * param string $id id number of the category/entry
	  * param array $type category/entry
	  * @author Ali Islami ( master@arkitus.com )
	  * @started 2002/7/19
	  **/
    	  
    	  function emoticon($string) 
    	  {
    	  	$emoticons = array ( ':D' 		=> "<img src='templates/" . $this->skinid . "/images/laugh.gif'>",
    	  			     ':)' 		=> "<img src='templates/" . $this->skinid . "/images/smile.gif'>",
				     ';)' 		=> "<img src='templates/" . $this->skinid . "/images/wink.gif'>",
				     ':(' 		=> "<img src='templates/" . $this->skinid . "/images/sad.gif'>");
		
		foreach ($emoticons as $key => $value )
		{
			$string = str_replace ($key, $value, $string);
		}
		
		return $string;
	  }
	  
	  /** --------------------------------------------
 	  * Decodes session string and transforms it into an array
 	  *
	  * param string $string srting to be decoded
	  * @author Ali Islami ( master@arkitus.com )
	  **/
    	  
    	  function decodeSession($string) 
    	  {
		$data = explode ("<!>", $string);
		$result['name'] 	= $data[0];
		$result['pass']		= $data[1];
		$result['mail']		= $data[2];
		$result['level'] 	= $data[3];
		$result['logged'] 	= $data[4];
		return $result;
	  }
	  
	  /** --------------------------------------------
 	  * Puts the URL in the address bar into a string.
 	  *
	  * @author Ali Islami ( master@arkitus.com )
	  **/
    	  
    	  function setUrl() 
    	  {
    	  	$this->url_start .= '?';
    	  	$this->url_sort .= '?';
    	  	
		foreach ( $this->get as $key => $value )
		{
			if ( strpos ( $key , 'start' ) !== 0 )
			{
				$this->url_start .= '&' . $key . '=' . $value;
			}
		}
		
		foreach ( $this->get as $key => $value )
		{
			if ( strpos ( $key , 'start' ) !== 0 AND strpos ( $key , 'sort' ) !== 0)
			{
				$this->url_sort .= '&' . $key . '=' . $value;
			}
		}
			
	  }
	  
	  /** --------------------------------------------
 	  * Location Bar identifier
 	  *
	  * @author Ali Islami ( master@arkitus.com )
	  **/
	  
	  function LocBarIdentify()
	  {

	  	if ( $this->get('catid') != NULL AND $this->get('action') != 'addentry')
	  	{
	  		$this->var = $this->locationBar($this->get['catid'], 'category');
	  	}
	  	elseif ( $this->get('entryid') != NULL AND $this->get('action') != 'comment')
	  	{
	  		$this->var = $this->locationBar($this->get['entryid'], 'entry');
	  	}
	  	elseif ( $this->get('action') == 'search')
	  	{
	  		$this->var = $this->locationBar('', 'search');
	  	}
	  	elseif ( $this->get('action') == 'register')
	  	{
	  		$this->var = $this->locationBar('', 'register');
	  	}
	  	elseif ( $this->get('action') == 'users')
	  	{
	  		$this->var = $this->locationBar('', 'login');
	  	}
	  	elseif ( $this->get('action') == 'addentry')
	  	{
	  		$this->var = $this->locationBar($this->get['catid'], 'addentry');
	  	}
	  	elseif ( $this->get('action') == 'comment')
	  	{
	  		$this->var = $this->locationBar($this->get['entryid'], 'comment');
	  	}
	  	elseif ( $this->get('action') == 'admin')
	  	{
	  		$admin = $this->get('admin');
 			if ($admin == NULL)
 			{
 				$admin = 'stats';
 			}
	  		$this->var = $this->locationBar($admin, 'admin');
	  	}
	  	elseif ( $this->get('entryid') == NULL AND $this->get('entryid') == NULL )
	  	{
	  		$this->var = $this->locationBar($this->get['catid'], 'category');
	  	}
	  	
	  	return $this->var;		
	  }
	  
	  /** --------------------------------------------
 	  * Cookies! Yum Yum.
 	  *
	  * @author Ali Islami ( master@arkitus.com )
	  **/
	  
	  function cookie()
	  {
	  	if ( empty($_COOKIE['arkidb']) )
	  	{
			$this->db( $db, "INSERT INTO `arkidb_sessions` ( `id`, `session_id`) VALUES ('', 'session_id()')", 0);

	  		setcookie ('arkidb', session_id(), time()+60*60*24*30);
	  	}
	  	else
	  	{  	
	  		$id = $_COOKIE['arkidb']; 
	  		session_unset();
	  		session_destroy();
	  		session_id($id); 
	  		session_start();
		}
	  }
	  
	  /** --------------------------------------------
 	  * The Statistics in the index
 	  *
	  * @author Ali Islami ( master@arkitus.com )
	  **/
	  
	  function getStats()
	  {	//Again, There are better SQL commands... -alpha
	  	$numberofentries = $this->db($db, 'SELECT * FROM arkidb_entries', '2:2');
	  	$mostpopentry = $this->db($db, 'SELECT id,Name FROM arkidb_entries ORDER BY entrydownloads DESC LIMIT 0,1', '1:2');
	  	$highestratedentry = $this->db($db, 'SELECT id,Name FROM arkidb_entries ORDER BY entryrating DESC LIMIT 0,1', '1:2');
		
	  	$entrytotal = $this->language['entrytotal'] . '<b>' . $numberofentries . '</b> ' . $this->language['statentries'] . '.';
	  	$mostpop = $this->language['mostpop'] . " <b><a href='index.php?action=view&view=entry&entryid=" . $mostpopentry['id'] . "'>" . $mostpopentry['Name'] . '</b></a>.';
	  	$highestrated = $this->language['highestrated'] . " <b><a href='index.php?action=view&view=entry&entryid=" . $highestratedentry['id'] . "'>" . $highestratedentry['Name'] . '</b></a>.';
	  	
		$info = array ( 'STATISTICS'	=> $this->language['statistics'],
				'ENTRYTOTAL'	=> $entrytotal,
				'MOSTPOP'	=> $mostpop,
				'HIGHESTRATED'	=> $highestrated );
		$this->tprint('statistics', $info);
	  }
				

	  /** 
 	  * Returns requested variable if it exists
 	  *
	  * @author Erik Karulf ( scriptmaster@alphamonkey.net )
	  **/
	  function get( $varname )
	  {
		if ( isset ( $_GET[$varname] ) )
		{
			return $_GET[$varname];
		}
		else
		{
			return NULL;
		}
	  }


	  /** 
 	  * Returns requested variable if it exists
 	  *
	  * @author Erik Karulf ( scriptmaster@alphamonkey.net )
	  **/
	  function post( $varname )
	  {
		if ( isset ( $_POST[$varname] ) )
		{
			return $_POST[$varname];
		}
		else
		{
			return NULL;
		}
	  }

	  /** 
 	  * Returns requested variable if it exists
 	  *
	  * @author Erik Karulf ( scriptmaster@alphamonkey.net )
	  **/
	  function request( $varname )
	  {
		if ($this->post($varname) != NULL)
		{
			return $this->post($varname);
		}
		else if ($this->get($varname) != NULL)
		{
			return $this->get($varname);
		}
		else
		{
			return NULL;
		}
	  }
	  

}


?>
