<?php

/**
 ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 :: Arki-DB                                                             ::
 :: (c) 2002 The Arki-DB Development Team                               ::
 ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 :: This program is free software; you can redistribute it and/or modify ::
 :: it under the terms of the GNU General Public License as published by ::
 :: the Free Software Foundation; either version 2 of the License, or    ::
 :: (at your option) any later version.                                  ::
 ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 
**/

/** --------------------------------------------
 * Admin CP
 *
 * @author Ali Islami ( master@arkitus.com )
 * @started 2002/7/21
 **/
 
 class admin extends ArkiDB
 {
 	function execute()
 	{	
 		$this->getTemplate(admin);
 		
 		$admin = $this->get('admin');
 		$stage = $this->get('stage');
 		
 		//--------------------------------------------
 		// Setting the default page
 		//--------------------------------------------
 		
 		if (!isset ($admin))
 		{
 			$admin = 'stats';
 		}
 		
 		//--------------------------------------------
 		// Print the header and the menu bar
 		//--------------------------------------------
 		
 		$this->tprint(startTable, array());
		$info = array ( 'MENU'		=> $this->language['menu'],
				'ADDCATEGORY'	=> $this->language['addcat'],
				'GENERAL'	=> $this->language['general'],
				'ADDOPTIONSET'	=> $this->language['addoptionset'],
				'EDITOPTIONSET'	=> $this->language['editoptionset'],
				'DELETEOPTIONSET'=>$this->language['deleteoptionset'],
				'EDITCATEGORY'	=> $this->language['editcat'],
				'DELETECATEGORY'=> $this->language['deletecat'],
				'ADDFIELD'	=> $this->language['addfield'],
				'EDITFIELD'	=> $this->language['editfield'],
				'DELETEFIELD'	=> $this->language['deletefield'],
				'ADDADMIN'	=> $this->language['addadmin'],
				'REMOVEADMIN'	=> $this->language['removeadmin'] );
		$this->tprint(startMenu, $info);
 		
 		//--------------------------------------------
 		// Make sure the user isn't hacking
 		//--------------------------------------------
 		if ( $this->session['level'] == 'admin' )
 		{
 			switch ($admin)
 			{
 				//--------------------------------------------
 				// Shows the ACP index page
 				//--------------------------------------------
 				
 				case 'stats':
 					$this->doStats($admin);
 					break;
 				
 				//--------------------------------------------
 				// Display General Preferences pages
 				//--------------------------------------------
 				
 				case 'general':
 					if ( $stage == '' )
 					{
 						$this->general($admin);
 					}
 					elseif ( $stage == '2' )
 					{
 						$this->doGeneral($admin);
 					}
	 				break;
	 			
	 			//--------------------------------------------
	 			// Display Add Category pages
	 			//--------------------------------------------
	 			
	 			case 'addcat':
	 				if ( $stage == '' )
	 				{
 						$this->addCat($admin);
 					}
 					elseif ( $stage == '2' )
 					{
 						$this->doAddCat($admin);
 					}
	 				break;
	 				
	 			//--------------------------------------------
	 			// Display Edit Category pages
	 			//--------------------------------------------
	 			
	 			case 'editcat':
	 				if ( $stage == '' )
	 				{
 						$this->editCat($admin);
 					}
 					elseif ( $stage == '2' )
 					{
 						$this->showEditCat($admin);
 					}
 					elseif ( $stage == '3' )
 					{
 						$this->doEditCat($admin);
 					}
	 				break;
	 			
	 			//--------------------------------------------
	 			// Display Delete Category pages
	 			//--------------------------------------------
	 			
	 			case 'deletecat':
	 				if ( $stage == '' )
	 				{
 						$this->deleteCat($admin);
 					}
 					elseif ( $stage == '2' )
 					{
 						$this->doDeleteCat($admin);
 					}
	 				break;
	 			
	 			//--------------------------------------------
	 			// Display Add Field pages
	 			//--------------------------------------------
	 			
	 			case 'addfield':
	 				if ( $stage == '' )
	 				{
 						$this->addField($admin);
 					}
 					elseif ( $stage == '2' )
 					{
 						$this->doAddField($admin);
 					}
	 				break;
	 			
	 			//--------------------------------------------
	 			// Display Edit Field pages
	 			//--------------------------------------------
	 				
	 			case 'editfield':
	 				if ( $stage == '' )
	 				{
 						$this->editField($admin);
 					}
 					elseif ( $stage == '2' )
 					{
 						$this->showEditField($admin);
 					}
 					elseif ( $stage == '3' )
 					{
 						$this->doEditField($admin);
 					}
	 				break;
	 			
	 			//--------------------------------------------
	 			// Display Delete Field pages
	 			//--------------------------------------------
	 				
	 			case 'deletefield':
	 				if ( $stage == '' )
	 				{
 						$this->deleteField($admin);
 					}
 					elseif ( $stage == '2' )
 					{
 						$this->doDeleteField($admin);
 					}
 				
 				//--------------------------------------------
	 			// Display Add Option Set pages
	 			//--------------------------------------------
 					
 				case 'addoptionset':
	 				if ( $stage == '' )
	 				{
 						$this->addOptionSet($admin);
 					}
 					elseif ( $stage == '2' )
 					{
 						$this->doAddOptionSet($admin);
 					}
	 				break;
	 			
	 			//--------------------------------------------
	 			// Display Edit Option Set pages
	 			//--------------------------------------------
	 				
	 			case 'editoptionset':
	 				if ( $stage == '' )
	 				{
 						$this->editOptionSet($admin);
 					}
 					elseif ( $stage == '2' )
 					{
 						$this->showEditOptionSet($admin);
 					}
 					elseif ( $stage == '3' )
 					{
 						$this->doEditOptionSet($admin);
 					}
	 				break;
	 				
	 			//--------------------------------------------
	 			// Display Delete Option Set pages
	 			//--------------------------------------------
	 				
	 			case 'deleteoptionset':
	 				if ( $stage == '' )
	 				{
 						$this->deleteOptionSet($admin);
 					}
 					elseif ( $stage == '2' )
 					{
 						$this->doDeleteOptionSet($admin);
 					}
	 				break;
	 			
	 			//--------------------------------------------
	 			// Display Delete Entry pages
	 			// NOTE: This cannot be accesed through the CP
	 			//--------------------------------------------

	 			case 'deleteentry':
	 				if ( $this->get('entryid') != NULL)
	 				{
 						$this->deleteEntry($admin);
 					}
	 				break;
	 			
	 			//--------------------------------------------
	 			// Display Edit Entry pages
	 			// NOTE: This cannot be accesed through the CP
	 			//--------------------------------------------
	 			
	 			case 'editentry':
	 				if ( $this->get('entryid') != NULL)
	 				{
 						if ( $stage == '' )
	 					{
 							$this->editEntry($admin);
 						}
 						elseif ( $stage == '2' )
 						{
 							$this->doEditEntry($admin);
 						}
 					}
	 				break;
	 			

	 			//--------------------------------------------
	 			// Add Admin Account
	 			//--------------------------------------------
	 			
	 			case 'addadmin':
	 				if ( $stage == '' )
	 				{
 						$this->addAdminAccount($admin);
 					}
 					elseif ( $stage == '2' )
 					{
 						$this->doAddAdminAccount($admin);
 					}
	 				break;
	 				
	 			//--------------------------------------------
	 			// Remove Admin Account
	 			//--------------------------------------------
	 			
	 			case 'removeadmin':
	 				if ( $stage == '' )
	 				{
 						$this->removeAdminAccount($admin);
 					}
 					elseif ( $stage == '2' )
 					{
 						$this->doRemoveAdminAccount($admin);
 					}
	 				break;
	 				
	 		}
	 	}
	 	
		//--------------------------------------------
		// Print the footer
		//--------------------------------------------
	 	$this->tprint(endMenu, array());
 		$this->tprint(endTable, array());
 	}
 	
	function done($admin)
	{
		
		//--------------------------------------------
		$info = array ( 'ADMINNAME'		=> $this->language[$admin] );
		$this->tprint(startAdminTable, $info);	
		$info = array ( 'DONE'			=> $this->language['admindone'],
				'URL'			=> "index.php?action=admin&admin=$admin" );
		$this->tprint(done, $info);
		$this->tprint(endAdminTable, $info);
		//--------------------------------------------
		
	}
	
	//--------------------------------------------
	// The Functions listed below are all related to 
	// the different parts of the Admin CP. 
	//
	// Only modify them if you know what you are doing
	// for it may corrupt your database.
	//--------------------------------------------

	//========================================================================================
	//========================================================================================
	
	function doStats($admin)
	{
		//--------------------------------------------
		$info = array ( 'ADMINNAME'	=> $this->language[$admin]);
		$this->tprint(startAdminTable, $info);
		//--------------------------------------------

		//--------------------------------------------
		$result = $this->db($db, 'SELECT * FROM arkidb_entries', '0');
		while ( $entry = mysql_fetch_object($result))
		{
			$this->var = $this->var + $entry->entryviews;
		}
		//--------------------------------------------
		
		//--------------------------------------------
		$totalrating = 0;
		while ( $rating = mysql_fetch_object($result))
		{
			@$totalrating = $totalrating + $rating->rating;
		}
		@$averagerating = round($totalrating/$numberofvotes, 2);
		//--------------------------------------------
		
		//--------------------------------------------
		@$totalviews = $this->var;
		@$numberofentries = $this->db($db, 'SELECT * FROM arkidb_entries', '2:2');
		@$averageentryviews = round($totalviews/$numberofentries, 2) ;
		@$numberofcats = $this->db($db, 'SELECT * FROM arkidb_cats WHERE categoryparent = 0', '2:2');
		@$numberofsubsandcats = $this->db($db, 'SELECT * FROM arkidb_cats', '2:2');
		@$numberofsubs = $numberofsubsandcats - $numberofcats;
		@$averagecatentries = round($numberofentries/$numberofsubsandcats, 2);
		$result = $this->db($db, 'SELECT * FROM arkidb_comments WHERE rating != 0', '0');
		//--------------------------------------------
		
		//--------------------------------------------
		$info = array ( $this->language['numberofentries']		=> $numberofentries,
				$this->language['totalviews']			=> $totalviews,
				$this->language['averageentryviews']		=> $averageentryviews,
				$this->language['numberofcats']			=> $numberofcats,
				$this->language['numberofsubs']			=> $numberofsubs,
				$this->language['averagecatentries']		=> $averagecatentries,
				$this->language['averagerating']		=> $averagerating, );

		foreach ( $info as $key => $value )
		{
			$row = array ( 'FIELD' => $key,
				       'VALUE' => $value);
			$this->tprint(row,$row);
		}
		
		$this->tprint(endAdminTable, $info);
		//--------------------------------------------
		
	}
	
	//========================================================================================
	//========================================================================================
	function general($admin)
	{
		
		//--------------------------------------------
		$info = array ( 'ADMINNAME'	=> $this->language[$admin],
				'ADMIN'		=> 'general&stage=2' );
		$this->tprint(startAdminTable, $info);
		//--------------------------------------------
		
		$result = $this->db($db, "SELECT * FROM arkidb_options WHERE optionid = 0 ORDER BY optiontype DESC", 0);
		while ( $option = mysql_fetch_object($result))
		{
			if ( $option->optiontype == 'yesno' )
			{
				$info = array ( 'NAME'		 => $option->optionname,
						'NAME_COMPLETE'	 => $this->language[$option->optionname],
						'YES'		 => $this->language['yes'],
						'NO' 		 => $this->language['no'] );
				
				if ( $option->optionvalue == 1 )
				{
					$info['CHECKEDY'] = 'checked';
				}
				else
				{
					$info['CHECKEDN'] = 'checked';
				}
				
				$this->tprint(yesno, $info);
			}
			elseif ( $option->optiontype == 'string' )
			{
				$info = array ( 'NAME'		=> $option->optionname,
						'NAME_COMPLETE'	=> $this->language[$option->optionname],
						'VALUE'		=> $option->optionvalue );
				
				$this->tprint(string, $info);
			}
			elseif ( $option->optiontype == 'int' )
			{
				$info = array ( 'NAME'		=> $option->optionname,
						'NAME_COMPLETE'	=> $this->language[$option->optionname],
						'VALUE'		=> $option->optionvalue );
				
				$this->tprint(int, $info);
			}
			
		}
		
		//--------------------------------------------
		$info = array(  'APPLY'		=> $this->language['apply'],
				'RESET'		=> $this->language['reset']);
		$this->tprint(endForm, $info);
		$this->tprint(endAdminTable, $info);
		//--------------------------------------------
		
	}	
	
	function doGeneral($admin)
	{
				 	
		foreach ( $this->post as $key => $value )
		{
			$this->db($db, "UPDATE `arkidb_options` SET `optionvalue` = '$value' WHERE `optionname` = '$key'", 0);
		}
		
		$this->done($admin);
	}
	
	//========================================================================================
	//========================================================================================
	
	function addCat($admin)
	{
		
		//--------------------------------------------
		$info = array ( 'ADMINNAME'	=> $this->language[$admin],
				'ADMIN'		=> 'addcat&stage=2' );
		$this->tprint(startAdminTable, $info);
		//--------------------------------------------
		
		$doeshavesuper = $this->db($db, "SELECT * FROM arkidb_cats", '2:2');
		
		$info = array ( 'NAME'		=> 'catname',
				'NAME_COMPLETE'	=> $this->language['name']);
		$this->tprint(string, $info);
		
		if ( $doeshavesuper != 0 )
		{
			$info = array ( 'NAME'		=> 'catdescription',
					'NAME_COMPLETE'	=> $this->language['catdescription']);
			$this->tprint(string, $info);
			
			$info = array ( 'NAME'		=> 'catimage',
					'NAME_COMPLETE'	=> $this->language['catimage']);
			$this->tprint(string, $info);

			$info = array ( 'NAME'		=> 'catsuper',
					'NAME_COMPLETE'	=> $this->language['catsuper'],
					'YES'		=> $this->language['yes'],
					'NO'		=> $this->language['no'],
					'CHECKEDY'	=> 'checked');
			$this->tprint(yesno, $info);
			
			$info = array ( 'NAME'		=> 'catparent',
					'NAME_COMPLETE'	=> $this->language['catparent'],
					'YES'		=> $this->language['yes'],
					'NO'		=> $this->language['no'],
					'CHECKEDY'	=> 'checked');
			$this->tprint(yesno, $info);
		
			//--------------------------------------------
			$select = "<select name='catparentid'><option value='0'>----Select----";
		
			$result = $this->db($db, "SELECT * FROM arkidb_cats ORDER BY categoryflag, categorylevel", 0);
			while ( $category = mysql_fetch_object ( $result ))
			{
				$dash = "";
			
				for ( $i=1; $i <= $category->categorylevel; $i++ )
				{
					$dash .= "+ ";
				}
			
				$name = $this->couple($dash, $category->categoryname);
				$select .= "<option value='$category->id'>$name";
			
			}
		
			$select .= "</select>";
			//--------------------------------------------
		
			$info = array ( 'NAME'		=> $this->language['ifcatparent'],
					'OPTION'	=> $select );
			$this->tprint(option, $info);
			
		}
		
		$select = "<select name='optionid'><option value='0'>----Select----";
		$result = $this->db($db, 'SELECT * FROM arkidb_options WHERE optionid != 0 ORDER BY id', 0);
		while ( $option = mysql_fetch_object($result))
		{
			if ( $this->var != $option->optionid )
			{
				$this->var = $option->optionid;
				$select .= "<option value='$option->optionid'>$option->optionid";
			}
		} 
		
		$select .= "</select>";
		$info = array ( 'NAME'		=> $this->language['id'],
				'OPTION'	=> $select );
		$this->tprint(option, $info);
		
		//--------------------------------------------
		$info = array(  'APPLY'		=> $this->language['apply'],
				'RESET'		=> $this->language['reset']);
		$this->tprint(endForm, $info);
		$this->tprint(endAdminTable, $info);
		//--------------------------------------------
		
	}	
	
	function doAddCat($admin)
	{
		
		$catname = $this->post('catname');
		$catimage = $this->post('catimage');
		$catdescription = $this->post('catdescription');
		$catsuper = $this->post('catsuper');
		$catparent = $this->post('catparent');
		$catparentid = $this->post('catparentid');
		$optionid = $this->post('optionid');
		$doeshavesuper = $this->db($db, "SELECT * FROM arkidb_cats", '2:2');

		if ( $doeshavesuper != 0 )
		{
			if ( $catparent != 1 )
			{
				if ( $catsuper == 1 )
				{
					$this->db( $db, "INSERT INTO `arkidb_cats` ( `id` , `categoryoptionid` , `categoryname` , `categorydescription` , `categoryimage` , `categoryparent` , `categoryflag` , `categorylevel` ) VALUES ( '', '$optionid', '$catname', '' , '' , '0', '0', '0' )", '0' );
				}
				elseif ( $catsuper == 0 )
				{
					if ( $catimage == '' )
					{
						$catimage = 'category.gif';
					}
					$parent = $this->db($db, "SELECT * FROM arkidb_cats WHERE id = $catparentid", '1:2');
					$level = $parent['categorylevel'] + 1;
					$flag = $parent['categoryflag'];
					$this->db( $db, "INSERT INTO `arkidb_cats` ( `id` , `categoryoptionid` , `categoryname` , `categorydescription` , `categoryimage` , `categoryparent` , `categoryflag` , `categorylevel` ) VALUES ( '', '$optionid', '$catname', '$catdescription' , '$catimage' , '$catparentid', '$flag', '$level' )", '0' );
				}
			}
			elseif ( $catparent == 1 )
			{
				if ( $catimage == '' )
				{
					$catimage = 'category.gif';
				}
				$lastflag = $this->db($db, "SELECT * FROM arkidb_cats ORDER BY categoryflag DESC LIMIT 0,1", '1:2');
				$flag = $lastflag['categoryflag'] + 1;
				$this->db( $db, "INSERT INTO `arkidb_cats` ( `id` , `categoryoptionid` , `categoryname` , `categorydescription` , `categoryimage` , `categoryparent` , `categoryflag` , `categorylevel` ) VALUES ( '', '$optionid', '$catname', '$catdescription' , '$catimage', '$catparentid', '$flag', '1' )", '0' );
			}
		}
		else
		{
			$this->db( $db, "INSERT INTO `arkidb_cats` ( `id` , `categoryoptionid` , `categoryname` , `categoryparent` , `categoryflag` , `categorylevel` ) VALUES ( '', '$optionid', '$catname', '0', '0', '0' )", '0' );
		}
		
		$this->done($admin);
		
	}	
	
	//========================================================================================
	//========================================================================================
	
	function editCat($admin)
	{
		//--------------------------------------------
		$info = array ( 'ADMINNAME'	=> $this->language[$admin],
				'ADMIN'		=> 'editcat&stage=2' );
		$this->tprint(startAdminTable, $info);
		//--------------------------------------------

		$select = "<select name='catid'><option value='0'>----Select----";
		
		$result = $this->db($db, "SELECT * FROM arkidb_cats ORDER BY categoryflag, categorylevel", 0);
		while ( $category = mysql_fetch_object ( $result ))
		{
			$dash = "";
			
			for ( $i=1; $i <= $category->categorylevel; $i++ )
			{
				$dash .= "+ ";
			}
			
			$name = $this->couple($dash, $category->categoryname);
			$select .= "<option value='$category->id'>$name";
			
		}
		
		$select .= "</select>";
		$info = array ( 'NAME'		=> $this->language['catedit'],
				'OPTION'	=> $select );
		$this->tprint(option, $info);
					
		//--------------------------------------------
		$info = array(  'APPLY'		=> $this->language['submit'],
				'RESET'		=> $this->language['reset']);
		$this->tprint(endForm, $info);
		$this->tprint(endAdminTable, $info);
		//--------------------------------------------
	}
	
	function showEditCat($admin)
	{
		$catid = $this->post('catid');
		
		//--------------------------------------------
		$info = array ( 'ADMINNAME'	=> $this->language[$admin],
				'ADMIN'		=> "editcat&stage=3&catid=$catid" );
		$this->tprint(startAdminTable, $info);
		//--------------------------------------------
	
		$category = $this->db($db, "SELECT * FROM arkidb_cats WHERE id = $catid", '1:2');

		$info = array ( 'NAME'		=> 'catname',
				'NAME_COMPLETE'		=> $this->language['name'],
				'VALUE'		=> $category['categoryname']);
		$this->tprint(string, $info);
		
		$info = array ( 'NAME'		=> 'catdescription',
				'NAME_COMPLETE'		=> $this->language['catdescription'],
				'VALUE'		=> $category['categorydescription']);
		$this->tprint(string, $info);
			
		$info = array ( 'NAME'		=> 'catimage',
				'NAME_COMPLETE'		=> $this->language['catimage'],
				'VALUE'		=> $category['categoryimage']);
		$this->tprint(string, $info);
	
		$select = "<select name='optionid'><option value='0'>----Select----";
		$result = $this->db($db, 'SELECT * FROM arkidb_options WHERE optionid != 0 ORDER BY id', 0);
		while ( $option = mysql_fetch_object($result))
		{
			if ( $this->var != $option->optionid )
			{
				$this->var = $option->optionid;
				$select .= "<option value='$option->optionid'>$option->optionid";
			}
		} 
		
		$select .= "</select>";
		$info = array ( 'NAME'		=> $this->language['id'],
				'OPTION'	=> $select );
		$this->tprint(option, $info);
		
		//--------------------------------------------
		$info = array(  'APPLY'		=> $this->language['apply'],
				'RESET'		=> $this->language['reset']);
		$this->tprint(endForm, $info);
		$this->tprint(endAdminTable, $info);
		//--------------------------------------------
	}
	
	function doEditCat($admin)
	{
		
		$catname = $this->post('catname');
		$catdescription = $this->post('catdescription');
		$catimage = $this->post('catimage');
		$optionid = $this->post('optionid');
		$catid = $this->get('catid');
		
		if ( $optionid == 0 )
		{
			$this->db($db, "UPDATE `arkidb_cats` SET `categoryname` = '$catname', `categorydescription` = '$catdescription', `categoryimage` = '$catimage' WHERE `id` = '$catid'", 0);
		}
		else
		{
			$this->db($db, "UPDATE `arkidb_cats` SET `categoryname` = '$catname', `categorydescription` = '$catdescription', `categoryimage` = '$catimage', `categoryoptionid` = '$optionid' WHERE `id` = '$catid'", 0);
		}
		
		$this->done($admin);
		
	}
	
	//========================================================================================
	//========================================================================================
	
	function deleteCat($admin)
	{
		//--------------------------------------------
		$info = array ( 'ADMINNAME'	=> $this->language[$admin],
				'ADMIN'		=> 'deletecat&stage=2' );
		$this->tprint(startAdminTable, $info);
		//--------------------------------------------

		$select = "<select name='catid'><option value='0'>----Select----";
		
		$result = $this->db($db, "SELECT * FROM arkidb_cats ORDER BY categoryflag, categorylevel", 0);
		while ( $category = mysql_fetch_object ( $result ))
		{
			$dash = "";
			
			for ( $i=1; $i <= $category->categorylevel; $i++ )
			{
				$dash .= "+ ";
			}
			
			$name = $this->couple($dash, $category->categoryname);
			$select .= "<option value='$category->id'>$name";
			
		}
		
		$select .= "</select>";
		$info = array ( 'NAME'		=> $this->language['catdelete'],
				'OPTION'	=> $select );
		$this->tprint(option, $info);
		
		//--------------------------------------------
		$info = array(  'APPLY'		=> $this->language['submit'],
				'RESET'		=> $this->language['reset']);
		$this->tprint(endForm, $info);
		$this->tprint(endAdminTable, $info);
		//--------------------------------------------
	}
	
	function doDeleteCat($admin)
	{
		
		$catid = $this->post('catid');

		$this->db($db, "DELETE FROM arkidb_cats WHERE `id` = $catid", 0);
		$this->db($db, "DELETE FROM arkidb_entries WHERE `entrycatid` = $catid", 0);
		
		$this->done($admin);
		
	}
	
	//========================================================================================
	//========================================================================================
	
	function editField($admin)
	{
		//--------------------------------------------
		$info = array ( 'ADMINNAME'	=> $this->language[$admin],
				'ADMIN'		=> "editfield&stage=2" );
		$this->tprint(startAdminTable, $info);
		//--------------------------------------------
			
		$select = "<select name='fieldid'><option value='0'>----Select----";
		$i = 1;
		$result = $this->db($db, 'SELECT * FROM arkidb_fields ORDER BY id', 0);
		while ( $field = mysql_fetch_object($result))
		{
					$select .= "<option value='$field->id'>$field->fieldname";
					$i++;			
		} 
		
		$select .= "</select>";
		//--------------------------------------------
		if ( $i == 1 )
		{
			$this->tprint(error, array('ERROR'	=> $this->language['nofield']));
		}
		else		
		{
			$info = array ( 'NAME'		=> $this->language['name'],
					'OPTION'	=> $select );
			$this->tprint(option, $info);
			$info = array(  'APPLY'		=> $this->language['submit'],
					'RESET'		=> $this->language['reset']);
			$this->tprint(endForm, $info);
		}
		$this->tprint(endAdminTable, $info);
		//--------------------------------------------
	}
	
	function showEditField($admin)
	{		
		$fieldid = $this->post('fieldid');
		
		//--------------------------------------------
		$info = array ( 'ADMINNAME'	=> $this->language[$admin],
				'ADMIN'		=> "editfield&stage=3&fieldid=$fieldid" );
		$this->tprint(startAdminTable, $info);
		//--------------------------------------------
		
		$field = $this->db($db, "SELECT * FROM arkidb_fields WHERE id = $fieldid", '1:2');
		
		$info = array ( 'NAME'		=> 'fieldname',
				'NAME_COMPLETE'		=> $this->language['name'],
				'VALUE'		=> $field['fieldname']);
		$this->tprint(string, $info);
		
		//--------------------------------------------
		$info = array(  'APPLY'		=> $this->language['apply'],
				'RESET'		=> $this->language['reset']);
		$this->tprint(endForm, $info);
		$this->tprint(endAdminTable, $info);
		//--------------------------------------------
	}
	
	function doEditField($admin)
	{
		
		$fieldid = $this->get('fieldid');
		$fieldname = $this->post('fieldname');
		
		$field = $this->db($db, "SELECT * FROM arkidb_fields WHERE id = $fieldid", '1:2');
		
		$this->db($db, "UPDATE `arkidb_fields` SET `fieldname` = '$fieldname' WHERE `id` = '$fieldid'", 0);
		$this->db($db, "ALTER TABLE `arkidb_entries` CHANGE `$field[fieldname]` `$fieldname` TEXT DEFAULT NULL", 0);
		
		$this->done($admin);
		
	}
	
	//========================================================================================
	//========================================================================================
	
	function addField($admin)
	{
		
		//--------------------------------------------
		$info = array ( 'ADMINNAME'	=> $this->language[$admin],
				'ADMIN'		=> 'addfield&stage=2' );
		$this->tprint(startAdminTable, $info);
		//--------------------------------------------
		
		$info = array ( 'NAME'		=> fieldname,
				'NAME_COMPLETE'		=> $this->language['name'] );
				
		$this->tprint(string, $info);
		
		$array = array ( $this->language['int']		=> 'int',
				 $this->language['text']	=> 'text',
				 $this->language['fulltext']	=> 'fulltext',
				 $this->language['picture']	=> 'picture' );
				 
		$select = "<select name='fieldtype'>";
		foreach ( $array as $key => $value )
		{
			$select .= "<option value='$value'>$key";
		}
		$select .= "</select>";
		$info = array ( 'NAME'		=> $this->language['type'],
				'OPTION'	=> $select );
		$this->tprint(option, $info);
		
		$select = "<select name='fieldoptionid'><option value='0'>----Select----";
		$i = 1;
		$result = $this->db($db, 'SELECT * FROM arkidb_options WHERE optionid != 0 ORDER BY id', 0);
		while ( $option = mysql_fetch_object($result))
		{
			if ( $this->var != $option->optionid )
			{
				$this->var = $option->optionid;
				$select .= "<option value='$option->optionid'>$option->optionid";
				$i++;
			}
		} 
		
		$select .= "</select>";
		$info = array ( 'NAME'		=> $this->language['id'],
				'OPTION'	=> $select );
		$this->tprint(option, $info);
		
		//--------------------------------------------
		$info = array(  'APPLY'		=> $this->language['apply'],
				'RESET'		=> $this->language['reset']);
		$this->tprint(endForm, $info);
		$this->tprint(endAdminTable, $info);
		//--------------------------------------------
		
	}
	
	function doAddField($admin)
	{
		
		$fieldtype = $this->post('fieldtype');
		$fieldname = $this->post('fieldname');
		$fieldoptionid = $this->post('fieldoptionid');
		
		$this->db($db, "INSERT INTO `arkidb_fields` ( `id` , `fieldoptionid` , `fieldname` , `fieldtype` ) VALUES ( '', '$fieldoptionid', '$fieldname', '$fieldtype' )", 0);
		$this->db($db, "ALTER TABLE `arkidb_entries` ADD `$fieldname` TEXT DEFAULT NULL", 0);
		$this->db($db, "ALTER TABLE `arkidb_entries` ADD FULLTEXT (`$fieldname`)", 0);
		
		$this->done($admin);
		
	}
	
	//========================================================================================
	//========================================================================================
	
	function deleteField($admin)
	{
		//--------------------------------------------
		$info = array ( 'ADMINNAME'	=> $this->language[$admin],
				'ADMIN'		=> 'deletefield&stage=2' );
		$this->tprint(startAdminTable, $info);
		//--------------------------------------------

		$select = "<select name='fieldname'><option value='0'>----Select----";
		
		$result = $this->db($db, 'SELECT * FROM arkidb_fields WHERE fieldoptionid != 0 ORDER BY id', 0);
		while ( $field = mysql_fetch_object($result))
		{
			$select .= "<option value='$field->fieldname'>$field->fieldname";
		} 
		
		$select .= "</select>";
		$info = array ( 'NAME'		=> $this->language['fielddelete'],
				'OPTION'	=> $select );
		$this->tprint(option, $info);
		
		//--------------------------------------------
		$info = array(  'APPLY'		=> $this->language['submit'],
				'RESET'		=> $this->language['reset']);
		$this->tprint(endForm, $info);
		$this->tprint(endAdminTable, $info);
		//--------------------------------------------
	}
	
	function doDeleteField($admin)
	{
		
		$fieldname = $this->post('fieldname');

		$this->db($db, "DELETE FROM arkidb_fields WHERE `fieldname` = '$fieldname'", 0);
		$this->db($db, "ALTER TABLE `arkidb_entries` DROP `$fieldname`", 0);
		
		$this->done($admin);
		
	}
	
	//========================================================================================
	//========================================================================================
	
	function deleteEntry($admin)
	{
		
		$entryid = $this->get('entryid');

		$this->db($db, "DELETE FROM arkidb_entries WHERE `id` = '$entryid'", 0);
		
		$this->done('stats');
		
	}
	
	//========================================================================================
	//========================================================================================
	
	function editEntry($admin)
	{
	
		$entryid = $this->get('entryid');
		
		//--------------------------------------------
		$info = array ( 'ADMINNAME'	=> $this->language[$admin],
				'ADMIN'		=> "editentry&stage=2&entryid=$entryid" );
		$this->tprint(startAdminTable, $info);
		//--------------------------------------------
		
		$entry = $this->db($db, "SELECT * FROM arkidb_entries WHERE id = $entryid", '1:2');
		$result = $this->db($db, 'SELECT * FROM arkidb_fields WHERE fieldoptionid = 0 ORDER BY fieldtype DESC', 0);
		while ( $field = mysql_fetch_object($result))
		{
			if ( $field->fieldname != 'Rating' )
			{
				$type = $field->fieldtype;
				$name = $field->fieldname;
				$value = $entry[$name];
				
				$this->tprint('e' . $type, array( 'NAME'		=> $name,
								  'TABINDEX'		=> $i,
								  'VALUE'		=> $value));
			}
		} 
				
		$result = $this->db($db, "SELECT * FROM arkidb_fields WHERE fieldoptionid = '$this->optionid' ORDER BY fieldtype DESC", 0);
		while ( $field = mysql_fetch_object($result))
		{
			$type = $field->fieldtype;
			$name = $field->fieldname;
			$value = $entry[$name];
				
			$this->tprint('e' . $type, array( 'NAME'		=> $name,
							  'TABINDEX'		=> $i,
							  'VALUE'		=> $value));
		} 

		//--------------------------------------------
		$info = array(  'APPLY'		=> $this->language['apply'],
				'RESET'		=> $this->language['reset']);
		$this->tprint(endForm, $info);
		$this->tprint(endAdminTable, $info);
		//--------------------------------------------
	
	}
	
	function doEditEntry($admin)
	{		

		$entryid = $this->get('entryid');
		$info = $this->post;
		
		foreach ( $info as $key => $value )
		{
			if ( $key != 'action' AND $key != 'submit' )
			{
				$this->db($db, "UPDATE `arkidb_entries` SET `$key` = '$value' WHERE `id` = '$entryid'", 0);
			}
		}
		
		$this->done('stats');
	
	}
	
	//========================================================================================
	//========================================================================================
	
	function addOptionSet($admin)
	{
		
		//--------------------------------------------
		$info = array ( 'ADMINNAME'	=> $this->language[$admin],
				'ADMIN'		=> 'addoptionset&stage=2' );
		$this->tprint(startAdminTable, $info);
		//--------------------------------------------
		
		$result = $this->db($db, "SELECT * FROM arkidb_options WHERE optionid = 1 ORDER BY optiontype DESC", 0);
		while ( $option = mysql_fetch_object($result))
		{
			if ( $option->optiontype == 'yesno' )
			{
				$info = array ( 'NAME'		=> $option->optionname,
						'NAME_COMPLETE'	 => $this->language[$option->optionname],
						'YES'		 => $this->language['yes'],
						'NO' 		 => $this->language['no'] );
				
				if ( $option->optionvalue == 1 )
				{
					$info['CHECKEDY'] = 'checked';
				}
				else
				{
					$info['CHECKEDN'] = 'checked';
				}
				
				$this->tprint(yesno, $info);
			}
			elseif ( $option->optiontype == 'string' )
			{
				$info = array ( 'NAME'		=> $option->optionname,
						'NAME_COMPLETE'	=> $this->language[$option->optionname],
						'VALUE'		=> $option->optionvalue );
				
				$this->tprint(string, $info);
			}
			elseif ( $option->optiontype == 'int' )
			{
				$info = array ( 'NAME'		=> $option->optionname,
						'NAME_COMPLETE'	=> $this->language[$option->optionname],
						'VALUE'		=> $option->optionvalue );
				
				$this->tprint(int, $info);
			}
			
		}
		
		//--------------------------------------------
		$info = array(  'APPLY'		=> $this->language['submit'],
				'RESET'		=> $this->language['reset']);
		$this->tprint(endForm, $info);
		$this->tprint(endAdminTable, $info);
		//--------------------------------------------
		
		
	}
	
	function doAddOptionSet($admin)
	{
		
		$lastoptionid = $this->db($db, "SELECT * FROM arkidb_options ORDER BY optionid DESC LIMIT 0,1", '1:2');
		$optionid = $lastoptionid['optionid'] + 1;
		
		$array = array ( 'usersubmit' 		=> $this->post('usersubmit'),
				 'div'			=> $this->post('div'),
				 'height'		=> $this->post('height'),
				 'entry' 		=> $this->post('entry'),
				 'entries' 		=> $this->post('entries'),
				 'view' 		=> $this->post('view'),
				 'views'		=> $this->post('views'));

		foreach ( $array as $key => $value )
		{
			if ( $key == 'usersubmit' OR $key == 'div')
			{
				$optiontype = 'yesno';
			}
			elseif ( $key == 'height' )
			{
				$optiontype = 'int';
			}
			else
			{
				$optiontype = 'string';
			}
			$this->db($db, "INSERT INTO `arkidb_options` ( `id` , `optionid` , `optionname` , `optionvalue` , `optiontype` ) VALUES ( '', '$optionid', '$key', '$value', '$optiontype' )", 0);
		}
		
		$this->done($admin);
	}
	
	//========================================================================================
	//========================================================================================
	
	function editOptionSet($admin)
	{
		//--------------------------------------------
		$info = array ( 'ADMINNAME'	=> $this->language[$admin],
				'ADMIN'		=> "editoptionset&stage=2" );
		$this->tprint(startAdminTable, $info);
		//--------------------------------------------
			
		$select = "<select name='optionid'><option value='0'>----Select----";
		$i = 1;
		$result = $this->db($db, 'SELECT * FROM arkidb_options WHERE optionid != 0 ORDER BY id', 0);
		while ( $option = mysql_fetch_object($result))
		{
			if ( $this->var != $option->optionid )
			{
				$this->var = $option->optionid;
				$select .= "<option value='$option->optionid'>$option->optionid";
				$i++;
			}
		} 
		
		$select .= "</select>";
		//--------------------------------------------
		$info = array ( 'NAME'		=> $this->language['id'],
				'OPTION'	=> $select );
		$this->tprint(option, $info);
		$info = array(  'APPLY'		=> $this->language['submit'],
				'RESET'		=> $this->language['reset']);
		$this->tprint(endForm, $info);
		$this->tprint(endAdminTable, $info);
		//--------------------------------------------
	}
	
	function showEditOptionSet($admin)
	{		
		$optionid = $this->post('optionid');
		
		//--------------------------------------------
		$info = array ( 'ADMINNAME'	=> $this->language[$admin],
				'ADMIN'		=> "editoptionset&stage=3&optionid=$optionid" );
		$this->tprint(startAdminTable, $info);
		//--------------------------------------------
		
		$result = $this->db($db, "SELECT * FROM arkidb_options WHERE optionid = $optionid ORDER BY optiontype DESC", 0);
		while ( $option = mysql_fetch_object($result))
		{
			if ( $option->optiontype == 'yesno' )
			{
				$info = array ( 'NAME'		 => $option->optionname,
						'NAME_COMPLETE'	 => $this->language[$option->optionname],
						'YES'		 => $this->language['yes'],
						'NO' 		 => $this->language['no'] );
				
				if ( $option->optionvalue == 1 )
				{
					$info['CHECKEDY'] = 'checked';
				}
				else
				{
					$info['CHECKEDN'] = 'checked';
				}
				
				$this->tprint(yesno, $info);
			}
			elseif ( $option->optiontype == 'string' )
			{
				$info = array ( 'NAME'		=> $option->optionname,
						'NAME_COMPLETE' => $this->language[$option->optionname],
						'VALUE'		=> $option->optionvalue );
				
				$this->tprint(string, $info);
			}
			elseif ( $option->optiontype == 'int' )
			{
				$info = array ( 'NAME'		=> $option->optionname,
						'NAME_COMPLETE'	=> $this->language[$option->optionname],
						'VALUE'		=> $option->optionvalue );
				
				$this->tprint(int, $info);
			}
			
		}
		
		//--------------------------------------------
		$info = array(  'APPLY'		=> $this->language['apply'],
				'RESET'		=> $this->language['reset']);
		$this->tprint(endForm, $info);
		$this->tprint(endAdminTable, $info);
		//--------------------------------------------
	}
	
	function doEditOptionSet($admin)
	{
		$optionid = $this->get('optionid');
		
		foreach ( $this->post as $key => $value )
		{		
			$this->db($db, "UPDATE `arkidb_options` SET `optionvalue` = '$value' WHERE `optionname` = '$key' AND `optionid` = '$optionid'", 0);
		}
		
		$this->done($admin);
		
	}
 	
 	//========================================================================================
	//========================================================================================
	
	function deleteOptionSet($admin)
	{
		//--------------------------------------------
		$info = array ( 'ADMINNAME'	=> $this->language[$admin],
				'ADMIN'		=> "deleteoptionset&stage=2" );
		$this->tprint(startAdminTable, $info);
		//--------------------------------------------
			
		$select = "<select name='optionid'><option value='0'>----Select----";
		$i = 1;
		$result = $this->db($db, 'SELECT * FROM arkidb_options WHERE optionid != 0 AND optionid!= 1 ORDER BY id', 0);
		while ( $option = mysql_fetch_object($result))
		{
			if ( $this->var != $option->optionid )
			{
				$this->var = $option->optionid;
				$select .= "<option value='$option->optionid'>$option->optionid";
				$i++;
			}
		} 
		
		$select .= "</select>";
		//--------------------------------------------
		$info = array ( 'NAME'		=> $this->language['id'],
				'OPTION'	=> $select );
		$this->tprint(option, $info);
		$info = array(  'APPLY'		=> $this->language['submit'],
				'RESET'		=> $this->language['reset']);
		$this->tprint(endForm, $info);
		$this->tprint(endAdminTable, $info);
		//--------------------------------------------
	}
	
	function doDeleteOptionSet($admin)
	{
	
		$optionid = $this->post('optionid');
		
		$this->db($db, "DELETE FROM arkidb_options WHERE optionid = '$optionid'", '0');

		$this->done($admin);
		
	}
 	
 	//========================================================================================
	//========================================================================================
	
	function addAdminAccount($admin)
	{
		//--------------------------------------------
		$info = array ( 'ADMINNAME'	=> $this->language[$admin],
				'ADMIN'		=> 'addadmin&stage=2' );
		$this->tprint(startAdminTable, $info);
		//--------------------------------------------

		$info = array ( 'NAME'		=> 'adminname',
				'NAME_COMPLETE'	=> $this->language['addadminname'] );
				
		$this->tprint(string, $info);
		
		//--------------------------------------------
		$info = array(  'APPLY'		=> $this->language['submit'],
				'RESET'		=> $this->language['reset']);
		$this->tprint(endForm, $info);
		$this->tprint(endAdminTable, $info);
		//--------------------------------------------
	}

	function doAddAdminAccount($admin)
	{
		$name = $this->post('adminname');
		$this->db( $db, "UPDATE `arkidb_users` SET `userlevel` = 'admin' WHERE `username` = '$name'" , '0' );
		
		$this->done($admin);
	}
	
	//========================================================================================
	//========================================================================================
	
	function removeAdminAccount($admin)
	{
		//--------------------------------------------
		$info = array ( 'ADMINNAME'	=> $this->language[$admin],
				'ADMIN'		=> 'removeadmin&stage=2' );
		$this->tprint(startAdminTable, $info);
		//--------------------------------------------

		$info = array ( 'NAME'		=> 'adminname',
				'NAME_COMPLETE'	=> $this->language['remadminname'] );
				
		$this->tprint(string, $info);
		
		//--------------------------------------------
		$info = array(  'APPLY'		=> $this->language['submit'],
				'RESET'		=> $this->language['reset']);
		$this->tprint(endForm, $info);
		$this->tprint(endAdminTable, $info);
		//--------------------------------------------
	}

	function doRemoveAdminAccount($admin)
	{
		$name = $this->post('adminname');
		
		if ($name == $this->session['name'])
		{
			echo "<b>You can not remove yourself as an administrator</b>";
		}
		else
		{
			$this->db( $db, "UPDATE `arkidb_users` SET `userlevel` = 'user' WHERE `username` = '$name'" , '0' );
		}
		
		$this->done($admin);
	}
	
	//========================================================================================
	//========================================================================================
}			
?>