<?php

/**
 ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 :: Arki-DB                                                              ::
 :: (c) 2002 The Arki-DB Development Team                                ::
 ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 :: This program is free software; you can redistribute it and/or modify ::
 :: it under the terms of the GNU General Public License as published by ::
 :: the Free Software Foundation; either version 2 of the License, or    ::
 :: (at your option) any later version.                                  ::
 ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 
**/

/** --------------------------------------------
 * Shows the categories and subcategories and entries
 *
 * @author Ali Islami ( master@arkitus.com )
 * @started 2002/7/21
 **/
 
 class view extends ArkiDB
 {
 	function execute()
 	{	
 		$this->setUrl();
 		
 		switch ($this->get('view'))
 		{
 			//--------------------------------------------
 			// Show the correct Category
 			//--------------------------------------------
 			
 			case 'category':
 				$this->showCat();
 				break;
 			
 			//--------------------------------------------
 			// Show the correct Entry
 			//--------------------------------------------
 				
 			case 'entry':
 				$this->showEntry();
 				break;
 				
 			//--------------------------------------------
 			// If nothing is set, show the index page
 			//--------------------------------------------
 			
 			default:
 				$this->showCat();
 				break;
 		}
 		
 	}
 	
 	/** --------------------------------------------
	 * Shows the correct category
      	 *
 	 * @author Ali Islami ( master@arkitus.com )
 	 * @started 2002/7/21
	 **/
	 
	 function showCat()
	 {
	 	//--------------------------------------------
	 	// Set the variables needed for outputting the
	 	// categories and subcategories 	
	 	//
	 	// No two categories can have the same variables
	 	//--------------------------------------------

			// The ID number of the category
	 		$catid = $this->get('catid');
	 	
	 		// The Flag number of the category. Flag numbers
	 		// indicate the ROOT of the categories
	 		$catflag = $this->get('catflag');
	 	
	 		// The sublevel of the category
	 		$sublevel = $this->get('sublevel');
	 	
	 		$this->getTemplate('view');
	 	
	 	//--------------------------------------------
	 	// Is the $catid set?
	 	//--------------------------------------------
	 	
	 	switch (isset($catid))
	 	{
	 		//--------------------------------------------
	 		// Nope, looks like we have to load the index
	 		//--------------------------------------------
	 		
	 		case FALSE:

				$query = $this->db($db, "SELECT id, categoryname FROM arkidb_cats 
							 WHERE categorylevel = 0", '0');
	 			while ( $super = mysql_fetch_object($query) )
	 			{
	 				//--------------------------------------------
	 				// Do anything require_onced, and set the variables then print
	 				//--------------------------------------------
	 				
						$this->mightysort('super_index');
	 					$config = $this->getConfig($super->id);
	 					$this->entries = $config['entries'];
	 					$this->views = $config['views'];
	 					$name = $this->couple( $this->language['category'] , $this->language['name'] );
	 					$super_name = "<a href='index.php?action=view&view=category&catid=" . $super->id . "&catflag=0&sublevel=1'>" . $super->categoryname . '</a>';
	 				
	 					//--------------------------------------------			
						$this->tprint('startTable',array( 'SUPER' => $super_name));
						$info = array ( 'NAME'			=> $name,
	 													'ENTRIESINCAT'		=> $this->entries,
	 													'LASTENTRY'		=> $this->language['lastentry']);
	 					$this->tprint('explaincatparent',$info);
	 					//--------------------------------------------
	 				
		 			$result = $this->db($db, "	SELECT * FROM arkidb_cats 
									WHERE categoryparent = '$super->id' AND categorylevel != 0  
									ORDER BY '$this->sort'", '0');
					while ( $category = mysql_fetch_object ($result))
					{		
							//--------------------------------------------
							// Set the variables needed for printing
							//--------------------------------------------
										
							$entriesincat = $this->db($db, " SELECT * FROM arkidb_entries WHERE entryflag = '$category->categoryflag'", '2:2');
							$nextsublevel = $category->categorylevel + 1;
							
							//--------------------------------------------
							// Retrieve the newest entry in the Root, then 
							// strip it until it fits into the cell
							//--------------------------------------------
							
							$latestentry = $this->db($db, " SELECT * FROM arkidb_entries WHERE entryflag = '$category->categoryflag' ORDER BY id DESC LIMIT 0,1", '1:2');
							$lastname = $latestentry['Name'];
														
								if (strlen($lastname) > 23)
								{
									$lastname = str_replace( "&#33;" , "!" , $lastname );
									$lastname = str_replace( "&quot;", "\"", $lastname );
									$lastname = substr($lastname,0,20) . "...";
									$lastname = preg_replace( '/&(#(\d+;?)?)?\.\.\.$/', '...', $lastname );
								}
								
							$lastentry = "<a href='index.php?action=view&view=entry&entryid=" . $latestentry['id'] . "'>" . $lastname . "</a>";
							
							//--------------------------------------------
							// Now that everything is set, print it
							//--------------------------------------------
							
							$info = array ( 'NAME'		=> $category->categoryname,
									'DESCRIPTION'	=> $category->categorydescription,
									'ENTRIESINCAT'	=> $entriesincat,
									'ID'		=> $category->id,
									'FLAG'		=> $category->categoryflag,
									'LEVEL'		=> $nextsublevel,
									'IMAGE'		=> $category->categoryimage,
									'LASTENTRY'	=> $lastentry);
							$this->tprint('catparent',$info);
					
					}
					
					//--------------------------------------------
					$this->tprint('endTable',array());
					//--------------------------------------------
				}
				//--------------------------------------------
				$this->getStats();
				//--------------------------------------------
				
				break;
				
			//--------------------------------------------
			// The $catid has been set, so we are in a category
			// lets display it!
			//--------------------------------------------
			
			case TRUE:
						
	 			//--------------------------------------------
	 			$currentcat = $this->db($db , "SELECT * FROM arkidb_cats WHERE id = $catid", '1:2');
 				$this->tprint('startTable',array( 'SUPER'			=> $currentcat['categoryname']));
	 			//--------------------------------------------
	 			
	 			if ( $currentcat['categorylevel'] != 0 )
	 			{
	 				//--------------------------------------------
	 				// If the category has subcategories, print them
	 				//--------------------------------------------
	 				
					$doeshavesub = $this->db($db, "SELECT id FROM arkidb_cats WHERE categoryparent = '$catid'", '2:2');
					if ( $doeshavesub != 0)
					{
	
						//--------------------------------------------
						$name = $this->couple($this->language['category'],$this->language['name']);
						$info = array ( 'NAME'			=> $name,
	 							'ENTRIESINCAT'		=> $this->entries);
	 					$this->tprint('explaincat',$info);
	 					//--------------------------------------------
					
						$result = $this->db($db, "SELECT * FROM arkidb_cats WHERE categoryparent = '$catid' AND categoryflag = '$catflag' ORDER BY id", '0');
						while ( $subcategory = mysql_fetch_object ($result))
						{
							$entriesinsub = $this->db($db, "SELECT * FROM arkidb_entries WHERE entrycatid = $subcategory->id", '2:2');				
							$info = array ( 'NAME'		=> $subcategory->categoryname,
									'DESCRIPTION'	=> $subcategory->categorydescription,
									'ID'		=> $subcategory->id,
									'ENTRIESINCAT'	=> $entriesinsub,
									'LEVEL'		=> $nextsublevel,
									'FLAG'		=> $subcategory->categoryflag,
									'IMAGE'		=> $subcategory->categoryimage );
							$this->tprint('cat',$info);
						
						}

					}
					
					//--------------------------------------------
	 				// If the category has entries, print them
	 				//--------------------------------------------
	 				
					$doeshaveentry = $this->db($db,"SELECT * FROM arkidb_entries WHERE entrycatid = '$catid'",'2:2');
					if ( $doeshaveentry != 0)
					{
						//--------------------------------------------
						$name = $this->couple($this->entry,$this->language['name']);
						$info = array ( 'NAME'			=> "<a href='" . $this->url_sort . "&sort=name'>" . $name . "</a>",
	 													'VIEWS'			=> "<a href='" . $this->url_sort . "&sort=numviews'>" .$this->language['numviews'] . "</a>",
	 													'RATING'		=> "<a href='" . $this->url_sort . "&sort=rating'>" .$this->language['rating'] . "</a>",
	 													'DATE'			=> "<a href='" . $this->url_sort . "'>" .$this->language['date'] . "</a>",
	 													'DOWNLOADS'	=> "<a href='" . $this->url_sort . "&sort=downloads'>" .$this->views . "</a>");
		 				$this->tprint('explainentry',$info);
		 				//--------------------------------------------
	 				}
	 				
	 				//--------------------------------------------
	 				// Sort the entries
	 				//--------------------------------------------
	 				
	 				$this->mightysort('entry');
	 				
	 				$numberofentries = $this->db($db,"SELECT * FROM arkidb_entries WHERE entrycatid = '$catid'" ,'2:2');
					$result = $this->db($db,"SELECT * FROM arkidb_entries WHERE entrycatid = '$catid' ORDER BY " . $this->sort ,'0');
					
					while ( $entry = mysql_fetch_object ($result))
					{
						if ( empty($entry->entryrating))
						{
							$entry->entryrating = 0;
						}
						
						if ( $this->submitter == 1 )
						{
							$stats = $entry->entrydate . "&nbsp;(" .$entry->entrysubmitter . ')';
						}
						else
						{
							$stats = $entry->entrydate;
						}
						$row = array (  'NAME'		=> $entry->Name,
								'DESCRIPTION'	=> $entry->ShortDescription,
								'ID'		=> $entry->id,
								'VIEWS'		=> $entry->entryviews,
								'DOWNLOADS'	=> $entry->entrydownloads,
								'RATING'	=> $entry->entryrating,	
								'STATS'		=> $stats,						
								'IMAGE'		=> 'entry');
						$this->tprint('entry',$row);
					}
					
					//--------------------------------------------
	 				// Show the link to the different pages
	 				//--------------------------------------------
					
					$numberofpages = $numberofentries/$this->limit;
					$currentpage = $this->start/$this->limit;
					
					$start = $this->language['pages'] . ' < ';
							
					if ( $numberofpages <= '1' )
					{
						$start .= '[1]';
					}
					else
					{
						$numberofpages = $numberofpages + 1;
						
						for ( $i = 1; $i < $numberofpages; $i++ )
						{
							if ( $this->start == 0 AND $i == 1 )
							{
								$start .= '[1]';
							}
							elseif ( $i-1 == $currentpage)
							{
								if ( $i == 1 )
								{
									$start .= '[1]';
								}
								else
								{
									$start .= ' [' . $i . ']';
								}
							}
							else
							{
								if ( $i == 1 )
								{
									$start .= '<a href=' . $this->url_start . '&start=' . (($i-1)*($this->limit)) . '>1</a>';
								}
								else
								{
									$start .= ' ' . '<a href=' . $this->url_start . '&start=' . (($i-1)*($this->limit)) . '>' . $i . '</a>';
								}
							}
						}
					}
					
					$start .= ' >';
					
					//--------------------------------------------
					$this->tprint('endtable',array());;
					//--------------------------------------------
				}
				
				//--------------------------------------------
				// This part shows the Super Categories on their own
				//
				// NOTE: If you wanted to know, this else answers the if 
				// around 80 lines back! EEK!
				//--------------------------------------------
				else 
				{
					
					$this->mightysort('super_index');
	 				
					//--------------------------------------------
					$name = $this->couple($this->language['category'],$this->language['name']);
					$info = array ( 'NAME'			=> $name,
	 						'ENTRIESINCAT'		=> $this->entries,
	 						'LASTENTRY'		=> $this->language['lastentry']);
	 				$this->tprint('explaincatparent',$info);
	 				//--------------------------------------------
					$result = $this->db($db, "SELECT * FROM arkidb_cats WHERE categoryparent = '$catid' AND categorylevel != 0", '0');
					while ( $category = mysql_fetch_object ($result))
					{
							$entriesincat = $this->db($db, " SELECT * FROM arkidb_entries WHERE entryflag = '$category->categoryflag'", '2:2');
							$nextsublevel = $category->categorylevel + 1;
							
							$latestentry = $this->db($db, " SELECT * FROM arkidb_entries WHERE entryflag = '$category->categoryflag' ORDER BY id DESC LIMIT 0,1", '1:2');
							$lastname = $latestentry['Name'];
							
							if (strlen($lastname) > 23)
							{
								$lastname = str_replace( "&#33;" , "!" , $lastname );
								$lastname = str_replace( "&quot;", "\"", $lastname );
								$lastname = substr($lastname,0,20) . "...";
								$lastname = preg_replace( '/&(#(\d+;?)?)?\.\.\.$/', '...', $lastname );
							}
							
							$lastentry = "<a href='index.php?action=view&view=entry&entryid=" . $latestentry['id'] . "'>" . $lastname . "</a>";	

							$info = array ( 'NAME'		=> $category->categoryname,
									'DESCRIPTION'	=> $category->categorydescription,
									'ENTRIESINCAT'	=> $entriesincat,
									'ID'		=> $category->id,
									'FLAG'		=> $category->categoryflag,
									'LEVEL'		=> $nextsublevel,
									'IMAGE'		=> $category->categoryimage,
									'LASTENTRY'	=> $lastentry);
							$this->tprint('catparent',$info);
					
					}
				
					//--------------------------------------------
					$this->tprint('endtable',array());
					//--------------------------------------------
				
				}
				break;
				
		 }
	 
	 }
	 
	 function showEntry()
	 {
		 //Show Entry. Probably the most used script, needs to be changed alot in terms of SQL...
		 //Also, we are too nice to visitors, we need to strip their comments for bad tags.
	 	$entryid = $this->get('entryid');
	 	
	 	//--------------------------------------------
	 	$print = "<a href='index.php?action=printentry&entryid=" . $entryid . "'>" . $this->language['print'] . "</a>";
	 	
	 	$this->getTemplate('entry');
	 	$this->tprint('startTable', array());
		$this->tprint('extras', array( 'PRINT'		=>		$print));
	 	//--------------------------------------------
	 	
	 	$entry = $this->db($db, "SELECT * FROM arkidb_entries WHERE id = $entryid", '1:2');
	 	$this->var = $entry['entryviews'] + 1;
	 	$this->db($db, "UPDATE arkidb_entries SET entryviews = $this->var WHERE id = $entryid LIMIT 1", '0');
	 	
	 	$result = $this->db($db, "SELECT * FROM arkidb_fields WHERE fieldoptionid = '0'", '0');
	 	while ( $field = mysql_fetch_object($result))
	 	{
		 		if ( $field->fieldname != 'URL' AND $field->fieldname != 'Rating' AND $field->fieldname != 'ShortDescription' AND $field->fieldtype != 'picture')
	 			{
	 				$fieldn = $field->fieldname;
	 				$row = array ( 'FIELD'		=> $field->fieldname,
	 					       'VALUE'		=> nl2br($entry["$field->fieldname"])
						     );
	 		
		 			$this->tprint('field', $row);
		 		}
	 			elseif ( $field->fieldname == 'URL' )
	 			{
	 				$this->var = $entry["$field->fieldname"];
		 		}
		 		elseif ( $field->fieldtype == 'picture' )
	 			{
	 				$info = array ( 'URL'	=> $entry["$field->fieldname"],
	 						'FIELD'	=> $field->fieldname );
		 			$this->tprint(picture, $info);
		 		}
	 			elseif ( $field->fieldname == 'Rating' )
	 			{
		 			$width = round(($entry['entryrating']*100)/4) - 6;
	 				$width2 = $width - 4;
	 				$number = ' ( ' . $entry['entryvotes'] . ' ' . $this->language['votes'] . ' )';
		 			$fieldn = $field->fieldname;
		 			$row = array ( 'FIELD'		=> $field->fieldname,
	 					       'VALUE'		=> $entry['entryrating'],
	 					       'WIDTH'		=> $width,
	 					       'WIDTH2'		=> $width2,
	 					       'NUMBER'		=> $number );
	 		
		 			$this->tprint('rating', $row);
		 		}
	 	}
	 	
	 	if ( $this->div == '1' )
	 	{
	 		$this->tprint('startdiv', array('HEIGHT'	=> $this->height));
	 	}
	 	
	 	$result = $this->db($db, "SELECT * FROM arkidb_fields WHERE fieldoptionid = $this->optionid ORDER BY id", '0');
	 	while ( $field = mysql_fetch_object($result))
	 	{
	 		if (!empty($entry["$field->fieldname"]))
		 	{
		 		if ( $field->fieldtype != 'picture' )
	 			{
	 				$fieldn = $field->fieldname;
	 				$row = array ( 'FIELD'		=> $field->fieldname,
	 					       'VALUE'		=> nl2br($entry["$field->fieldname"])
						     );
	 		
		 			$this->tprint('field', $row);
		 		}
		 		elseif ( $field->fieldtype == 'picture' )
	 			{
	 				$info = array ( 'URL'	=> $entry["$field->fieldname"],
	 						'FIELD'	=> $field->fieldname );
		 			$this->tprint(picture, $info);
		 		}
	 		}
	 	}
	 	
	 	if ( $this->div == '1' )
	 	{
	 		$this->tprint('enddiv', array());
	 	}
	 	
	 	if ( $this->session['logged'] != TRUE )
	 	{
	 		if ( $this->viewentry == 0 )
	 		{
	 			$viewentry = $this->language['login'];
	 			$url = "index.php?action=users&useraction=loginform";
	 		}
	 		else
	 		{
	 			$viewentry = $this->view . ' ' . $this->entry;
	 			$url = "index.php?action=visit&entryid=$entryid";
	 		}
	 	}
	 	else
	 	{
	 		$viewentry = $this->view . ' ' . $this->entry;
	 		$url = "index.php?action=visit&entryid=$entryid";
	 	}
	 	$commententry = $this->language['comment'] . ' ' . $this->entry;
	 	$rateentry = $this->language['rate'] . ' ' . $this->entry;
	 	$this->tprint('functions', array( 'VIEWENTRY'		=> $viewentry,
	 					  'COMMENTENTRY'	=> $commententry,
	 					  'URL'			=> $url,
	 					  'RATEENTRY'		=> $rateentry,
	 					  'ID'			=> $entryid));
	 					  
		$this->mightysort('comments');
		
		$result = $this->db($db, "SELECT name,comment,rating FROM arkidb_comments WHERE entryid = $entryid ORDER BY $this->sort DESC", '0');
		
		//--------------------------------------------
	 	$explain = $this->language['comments'];
	 	$this->tprint('spacer', array());
		$this->tprint('explain', array( 'EXPLAIN'	=>		$explain));
		//--------------------------------------------
		
		while ( $comment = mysql_fetch_object($result))
		{
			if ( $comment->comment != '')
			{
				if ( $this->emoticons == 1)
				{
					$cmnt = $this->emoticon(nl2br($comment->comment));
				}
				else 
				{
					$cmnt = nl2br($comment->comment);
				}
				
				$rating = $this->language['rating'] . ': ' . $comment->rating;
				
				$info = array ( 'NAME'		=> $comment->name,
						'COMMENT'	=> $cmnt,
						'RATING'	=> $rating );
				$this->tprint('comments', $info);
			}
		
		}
		
	 	//--------------------------------------------
	 	$string = "[ <a href='" . $this->url_sort . "&sort=rating'>" . $this->language['rating'] . "</a> ]";
	 	$this->tprint('endTable',array( 'SORT'		=> $string,
	 					'SORTBY'	=> $this->language['sortby']));
	 	//--------------------------------------------
	 }
	 
/** --------------------------------------------
 * The mighty sort function
 *
 * PHP won't accept sort()... what should i call
 * it? mightysort()-vsort()-arkisort()?
 *
 * PHP allready has sorting functions built in :D, but...
 * if you want to use yours, db_sort? q-sort
 **/
	 
	 function mightysort($type)
	 {
	 	$sort = $this->sort;
	 	
	 	switch( $type )
	 	{
	 		
	 		//--------------------------------------------
	 		// Sort the index page / super cats
	 		//--------------------------------------------
	 		
	 		case 'super_index':
	 			switch ( $this->sort )
	 			{		
	 				case 'name':
	 					$this->sort = 'categoryname';
	 					break;
	 				case '':
	 					$this->sort = 'id';
	 					break;
	 			}
	 			break;
	 		
	 		//--------------------------------------------
	 		// Sort the entries of a category
	 		//--------------------------------------------
	 		
	 		case 'entry':
	 		
				if ( $this->start == '' ) $this->start = '0';
				if ( $sort == '' ) $sort = 'id';

	 			switch ( $sort )
	 			{	
	 				case 'name':
	 					$this->sort = 'Name LIMIT ' . $this->start . ', ' . $this->limit;
	 					break;
	 					
	 				case 'rating':
	 					$this->sort = 'entryrating DESC LIMIT ' . $this->start . ', ' . $this->limit;
	 					break;
	 					
	 				case 'numviews':
	 					$this->sort = 'entryviews DESC LIMIT ' . $this->start . ', ' . $this->limit;
	 					break;
	 					
	 				case 'downloads':
	 					$this->sort = 'entrydownloads DESC LIMIT ' . $this->start . ', ' . $this->limit;
	 					break;
	 			
	 				case 'id':
	 					$this->sort = 'id DESC LIMIT ' . $this->start . ', ' . $this->limit;
	 					break;
	 			}
	 			break;
	 				
	 		//--------------------------------------------
	 		// Sort the comments on an entry
	 		//--------------------------------------------
	 		
	 		case 'comments':
	 			switch ( $sort )
				{
					case '':
						$this->sort = 'id';
						break;
				
					case 'rating':
						$this->sort = 'rating';
						break;
				}
				break;
	 	}
	}
}			
?>